<?php

/** * @description This class provides all the functionality for an ia (interactive activities)
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão and Luciano Oliveira Borges
 *  * @version $Id: ia.class.php$ v 1.0 2012/01/10$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2012/01/10
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */

require_once("../../config.php");


$imainstance = new editor_ima();


/**
 * Standard base class for all iAssign.
 */
class editor_ima {
    var $context;
    var $action;
    var $id;
    
    /**
     * Constructor for the base editor_ima class
     */
    function editor_ima() {
        global $COURSE, $CFG,$USER;
        
        $this->id = optional_param('id', NULL);
            
        $this->context = get_context_instance(CONTEXT_COURSE, $this->id);
          
        if (has_capability('moodle/legacy:editingteacher', $this->context, $USER->id)){
            $this->action = optional_param('action', NULL);
            print_header_simple();
            if($this->action=='editor')
               $this->ima_editor();
            else
               $this->add_edit_ima();
            print_footer();
        }
    }

       
    /**
     * Add or Edit interactive activities
     */
    function add_edit_ima() {
        global $USER, $CFG, $COURSE;
  
        require_once('editor_ima_form.php');
 
        $param = new object();
        $param->id=$this->id;
        $COURSE->id=$this->id;
        $param->tag="";    
        $mform = new block_editor_ima_form();
        $mform->set_data($param);
        $result = $mform->get_data();
         
        if ($mform->is_cancelled()) {
            close_window();
        }elseif ($result=$mform->get_data()) {
                     
            redirect("$CFG->wwwroot/course/view.php?id=$result->id",get_string('return_home_course','ia'),0);
           
        }
        $mform->display();
        die;
    }

    
 
     /**
     * View iGeom editor online
	 * @author: Luciano Oliveira Borges
	 * @last modification date 2011/11/16
     */
    function ima_editor() 
	{
                global $USER, $CFG, $COURSE;
                
                //inicio: inserido pela Patricia        
                $id = optional_param('id', 0, PARAM_INT); // Course ID
                //termino
                $COURSE->id=$id;
                $ia_content = "";
		$ia_file = $_GET['ia_file'];
            
		if($ia_file != "" && empty ($_POST))
		{
                        $path = "$CFG->dataroot/$COURSE->id/$ia_file";
                        if(file_exists($path))
			    $ia_content = file_get_contents($path, true);
		}
		echo "<script type='text/javascript'>\n";
		echo "function submit_MA_Answer () {\n";
		echo " var docForm = document.formEnvio;\n";
		echo " var resposta_exerc = new Array(3); \n";
		echo " var valor_resposta = new Array(3); \n";
		echo " var sessao = new Array(3);\n";
		echo " var doc = document.eMA; \n";
		echo " resposta_exerc[0] = doc.getAnswer();\n";
		echo " valor_resposta[0] = doc.getEvaluation();\n";
		echo " docForm.MA_POST_Value.value = valor_resposta[0]; \n";
		echo " docForm.MA_POST_Archive.value = resposta_exerc[0];\n";
		echo " if(resposta_exerc[0] == 'Vazio'){alert('".get_string('error_null_ia', 'ia')."');return false;}\n";
		if($ia_file != "")
		{
			echo " if(!docForm.MA_POST_Version.checked){";
                        echo " var answer = confirm('".get_string('overwrite_file_ia', 'ia')."');";
			echo " if (answer){";
			echo " docForm.submit(); \n";
			echo " return true;\n";
			echo " } else {\n";
			echo " return false;\n";
			echo " }\n";
			echo " } else {";
			echo " docForm.submit(); \n";
			echo " return true;\n";
			echo " }\n";
			
		} else
		{
			echo " docForm.submit(); \n";
			echo " return true;\n";
		}
		echo " }\n";
		echo "</script>\n";
		echo "<table width='100%'><tr><td colspan='2'><center><b>".get_string('title_editor_ia', 'ia')."</b>";
		echo "<a title='".get_string('help_button_ia', 'ia')."' href='$CFG->wwwroot/help.php?module=ia&amp;file=editor.html&amp;forcelang=' ";
		echo "onclick=\"this.target='popup'; return openpopup('/help.php?module=ia&amp;file=editor.html&amp;forcelang=', 'popup', 'menubar=0,location=0,scrollbars,resizable,width=500,height=400', 0);\">";
		echo "<img class='iconhelp' alt='".get_string('help_button_ia', 'ia')."' src='$CFG->wwwroot/pix/help.gif'></a>";
		echo "</center></td></tr>";
                echo "<tr><td width='50%'>".get_string('label_author_ia', 'ia')."<b>".$USER->firstname . ' ' . $USER->lastname."</td><td width='50%'>".get_string('label_file_ia', 'ia')."<b>$ia_file</b></td></tr>";
 		echo "</table>";
		echo "<center>\n";
		echo "<form name='formEnvio' id='formEnvio' method='post' enctype='multipart/form-data'>\n";
		echo "<applet name='eMA' codebase='../../mod/ia/ma/' code='IGeomApplet.class' archive='iGeom.jar' WIDTH='700' HEIGHT='500' vspace='10' hspace='10'>\n";
		echo "<param name='lang' value='pt'/>\n";
		echo "<param name='MA_PARAM_Proposition' value='$ia_content'/>\n";
		echo "</applet>\n";
		echo "<br/>\n";
		echo "<input type='hidden' name='MA_POST_Archive'/>\n";
		echo "<input type='hidden' name='MA_POST_Value'/>\n";
		echo "<input type='hidden' name='MA_POST_Name' />\n";
		echo "<center>\n";
		if($ia_file != "" && empty ($_POST))
			echo "<input name='MA_POST_Version' type=checkbox value='Y'><font color=red>".get_string('question_version_ia', 'ia')."</font></br>\n";
		echo "<input type=button value='".get_string('label_write_ia', 'ia')."' title='' onclick='submit_MA_Answer();'/>\n";
		echo "</center>\n";
		echo "</form>\n";
		echo "</center>\n";
                if(!empty ($_POST))    
		{
			$filename = $_POST['MA_POST_Name'];
			if($ia_file != "")
				$filename = $ia_file;
		        if(empty ($_POST['MA_POST_Version']))
                            $_POST['MA_POST_Version']="";
                        
                        $this->ima_save_files($filename, $CFG->dataroot, $COURSE->id, $_POST['MA_POST_Archive'], $ia_file != "" && $_POST['MA_POST_Version'] != 'Y');
		}
		die;
    }
     /**
     * Save iGeom file
	 * @author: Luciano Oliveira Borges
	 * @last modification date 2011/11/16
     */
    function ima_save_files($filename, $data_folder, $course, $content, $file_exists) 
	{
		if($filename == "")
			$filename = get_string('model_name_ia', 'ia');
		$cont = -1;
		$filename = $this->format_filename($filename);
		if(!$file_exists)
		{
			$afile = explode(".", $filename);
			if(count($afile) > 1)
				array_pop($afile);
			$filename = join("", $afile);
			$afile = explode("_v", $filename);
			if(count($afile) > 1)
				array_pop($afile);
			$filename = join("", $afile);
			do
			{
				if($cont == -1)
					$file = "$filename.geo";
				else
					$file = $filename."_v"."$cont.geo";
				$path = "$data_folder/$course/$file";
				$cont++;
			} while(file_exists($path));
		} else
		{
			$file = "$filename";
			$path = "$data_folder/$course/$filename";
		}
                
                $fh = fopen($path, 'w') or 
		die("<script>alert('".get_string('error_write_ia', 'ia')."');</script>");
		fwrite($fh, $content);
		fclose($fh);
		echo("<script>alert('".get_string('sucess_write_ia', 'ia', $file)."');\n");
		echo("window.opener.document.getElementById('id_file_value').value = '$file';\n");
		die("window.close();</script>");
    }
     /**
     * Format filename for save in data dir.
	 * @author: Luciano Oliveira Borges
	 * @last modification date 2011/11/16
     */
	function format_filename( $text )
	{
		$text = htmlspecialchars(urldecode($text));
		$array1 = array(   "á", "à", "â", "ã", "ä", "é", "è", "ê", "ë", "í", "ì", "î", "ï", "ó", "ò", "ô", "õ", "ö", "ú", "ù", "û", "ü", "ç"
						 , "Á", "À", "Â", "Ã", "Ä", "É", "È", "Ê", "Ë", "Í", "Ì", "Î", "Ï", "Ó", "Ò", "Ô", "Õ", "Ö", "Ú", "Ù", "Û", "Ü", "Ç"
						 , "@", " ", "!", "?");
		$array2 = array(   "a", "a", "a", "a", "a", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", "o", "u", "u", "u", "u", "c"
						 , "A", "A", "A", "A", "A", "E", "E", "E", "E", "I", "I", "I", "I", "O", "O", "O", "O", "O", "U", "U", "U", "U", "C"
						 , "-", "_", "", "");
		return str_replace( $array1, $array2, $text );
	}

}
?>
