<?php

/** * @description Form to add and edit interactive activities
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão and Luciano Oliveira Borges
 *  * @version $Id: editor_ima_form.php$ v 1.0 2012/01/10$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2012/01/10
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */


if (!defined('MOODLE_INTERNAL')) {
    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
}

require_once ($CFG->dirroot . '/course/moodleform_mod.php');

class block_editor_ima_form extends moodleform {

    function definition() {
        global $CFG, $COURSE, $USER;
        $mform = & $this->_form;
        
        $igeom=get_record('ia_ima','name','iGeom','parent',0);
        
        //-----
         ///javascripts
         $code_javascript="
             <script type='text/javascript'>
             <!--
                function config_tag_filter(file)
                {
                document.forms['mform1'].tag.value='<ia toolbar=disable width=600 height=300>'+file+'</ia>';
                 }
        
		function open_online_ima()
		{
			
			ia_file=document.getElementById('id_file_value').value;
                        new_ima=window.open('$CFG->wwwroot/blocks/editor_ima/editor_ima.php?id=$COURSE->id&action=editor&&ia_file='+ia_file,'','menubar=0,location=0,scrollbars,status,fullscreen,resizable');
		}
		</script>";
       
        ///-----------------------------------------------------------------------------
        /// Adding the "interactivy_learning_module" fieldset, where all the common settings are showed
        $mform->addElement('header', 'interactivy_learning_module', get_string('interactivy_learning_module', 'ia'));
       

        // Search imas registered in the database
        $enable=1;
        $sql="SELECT s.id, s.name
          FROM {$CFG->prefix}ia_ima s
           WHERE s.enable = $enable";
        $mas = get_records_sql ($sql);
       
        $applets = array();
        foreach ($mas as $ma) 
            $applets[$ma->id] = $ma->name;

		$ia_array=array();

 
		$ia_array[] =& $mform->createElement('select', 'ia_ima_id', get_string('choose_iMA', 'ia'), $applets);
		$ia_array[] =& $mform->createElement('button', 'online_new_ia', get_string('online_new_ia', 'ia'), array('onClick'=>'open_online_ima()'));

        $mform->addElement('choosecoursefile', 'file', get_string('file', 'ia'), array('courseid' => $COURSE->id),array('onClick'=>'config_tag_filter(this.value);'));
        $mform->setHelpButton('file', array('file', get_string('file', 'ia'), 'ia'));

        $mform->addGroup($ia_array, 'select_ia', get_string('choose_iMA', 'ia'), array(' '), false);
        $mform->setHelpButton('select_ia', array('iMA', get_string('iMA', 'ia'), 'ia'));
		
	
        $mform->addRule('file', get_string('required', 'ia'), 'required', null, 'server');

        $mform->addElement('text','tag',get_string('tag_filter', 'block_editor_ima'),array('size' => '55'));
        $mform->setHelpButton('tag', array('filter_iMA', get_string('tag_filter', 'block_editor_ima'), 'ia'));
        //-------------------------------------------------------------------------------
        // Hidden fields
        $mform->addElement('html', $code_javascript);
        
        $mform->addElement('hidden', 'id');
        // add standard elements, common to all modules
        $this->add_action_buttons(false,get_string('close', 'block_editor_ima'));
    }
}
?>
