<?php

/** * @description Filter iAssign
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: filter.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2010/12/21
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */


function iaFilter_filter ($courseid, $text) {
    global $CFG;

    $strs = explode("&lt;/ia&gt;", $text); // < (&lt;) - >(&gt;)
    if (count($strs)>1) {
       $expressions = array();
       foreach($strs as $str) {
           $tmp = explode("&lt;ia", $str); // < (&lt;) - / (&frasl;) >(&gt;)
           if (count($tmp)>1)
               $expressions[]=trim($tmp[1]);
           } //foreach($strs as $str)

       $text = str_replace("&lt;/ia&gt;","<br/>",$text);
       $text = str_replace("&lt;ia","<br/>",$text);

       foreach ($expressions as $expression) {
           // default
           $toolbar = disable; // enable (habilita a barra de botões) disable (desabilita a barra de botões)
           $width = 800;
           $height = 600;

           $tmp = explode("&gt;",$expression); //  >(&gt;)
           $params = trim($tmp[0]);
           $fileName = trim($tmp[1]);
       
           $params = str_replace("'","",$params);
           $params = str_replace("&quot;","",$params);
           $params = explode(" ", $params);

           foreach ($params as $param) {
               $tmp1 = explode("=", $param);
               if ($tmp1[0]=="toolbar")
                   $toolbar = $tmp1[1];
               if ($tmp1[0]=="width")
                   $width = $tmp1[1];
               if ($tmp1[0]=="height")
                   $height = $tmp1[1];
               } //foreach($params as $param)

           $file_location = $CFG->dataroot.DIRECTORY_SEPARATOR.$courseid.DIRECTORY_SEPARATOR.$fileName;
           $file_string = utf8_encode(file_get_contents($file_location));

           if (!file_exists($file_location)) {
              $applet = "<strong>".$fileName.": ".get_string('filenotfound', 'ia')."</strong>";
              }
           else {
              $applet = convert_applet($fileName,$width,$height,$toolbar,$file_string);
              }
           $text = str_replace($expression,$applet,$text);
           } // foreach($expressions as $expression)
       } // if (count($strs)>1)

    return $text;
    }

function convert_applet ($fileName,$width,$height,$toolbar,$file_string) {
    global $CFG;

    $extension = explode(".",$fileName);
    $ia_applets = get_record("ia_ima",'extension',$extension[1],'parent',0);
    $ext = $extension[1];
    if (empty ($ia_applets)) {
       $applet = "<strong>".$ext.": ".get_string('extensionnotfound', 'ia')."</strong>";
       }
    else {
       $lang = substr(current_language(),0,2);
       $file_jar = $ia_applets->file_jar;
       $file_class = $ia_applets->file_class;
       $elm = $CFG->wwwroot."/mod/ia/ma/".$file_jar;
       $applet = "
    <applet name='eMA' codebase='.' code='$file_class' archive='$elm' width='$width' height='$height' vspace=10 hspace=10>";
       if ($toolbar=="disable")
          $applet .= "
     <param name='SOH_ADD' value='ADD'>";
       $applet .= "
     <param name='MA_PARAM_notSEND' value='false'/>
     <param name='lang' value='$lang'>
     <param name='enderecoPOST' value=''>
     <param name='MA_PARAM_Proposition' value='$file_string'>
    </applet>";
    }
    return $applet;
}
?>
