<?php

/** * @description Form to add and edit interactive activities
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão and Luciano Oliveira Borges
 *  * @version $Id: assign_form.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2011/11/16
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */


if (!defined('MOODLE_INTERNAL')) {
   die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
   }

require_once ($CFG->dirroot . '/course/moodleform_mod.php');
require_once ($CFG->dirroot . '/mod/ia/lib.php');

class mod_assign_form extends moodleform {

 function definition () {
   global $CFG, $COURSE, $USER;
   $mform = & $this->_form;

   $igeom=get_record('ia_ima','name','iGeom','parent',0);
   $tmps=get_records_sql("SELECT s.id, s.name, s.evaluate
         FROM {$CFG->prefix}ia_ima s
         WHERE s.enable = 1");

   $ids = "";
   $names= "";
   $evaluates= "";
   foreach ($tmps as $tmp) {
       $ids .="'".$tmp->id."',";
       $names .="'".$tmp->name."',";
       $evaluates .="'".$tmp->evaluate."',";
       }
   $ids .="'0'";
   $evaluates .="'0'";
   //-----
   ///javascripts
   $code_javascript="
     <script type='text/javascript'>
     <!--

     var i;
     var ids = new Array($ids);
     var evaluates = new Array($evaluates);
     if (document.forms['mform1'].type_assign.value==1) {
        document.forms['mform1'].grade.style.display='none';
        document.forms['mform1'].max_experiment.style.display='none';
     } else {
        document.forms['mform1'].grade.style.display='block';
        document.forms['mform1'].max_experiment.style.display='block';
        }

     for (i=0;i<ids.length;i++) {
       if (ids[i]==document.forms['mform1'].ia_ima_id.value && evaluates[i]==0) {
          document.forms['mform1'].automatic_evaluate.style.display='none';
          document.forms['mform1'].show_answer.style.display='none';
          //document.forms['mform1'].automatic_evaluate.disabled=1;
          // document.forms['mform1'].show_answer.disabled=1;
          }
       }

     if (document.forms['mform1'].ia_ima_id.value==$igeom->id) {
       document.forms['mform1'].special_param1.style.display='block';
       document.forms['mform1'].special_param1.disabled=0;
       }
     else {
       document.forms['mform1'].special_param1.style.display='none';
       document.forms['mform1'].special_param1.value=0;
       document.forms['mform1'].special_param1.disabled=1;
       }


  function config_ima (id) {
     //DEBUG: if you need to disable any iLM use somenthing link this
     //T if (id<>$igeom->id) { // disable any iLM other than iGeom
     //T    document.forms['mform1'].online_new_ia.style.visibility='hidden';
     //T    document.forms['mform1'].special_param1.style.display='none';
     //T    document.forms['mform1'].special_param1.value=0;
     //T    document.forms['mform1'].special_param1.disabled=1;
     //T    }
     //T else {
       document.forms['mform1'].special_param1.style.display='block';
       document.forms['mform1'].special_param1.disabled=0;
       document.forms['mform1'].online_new_ia.style.visibility='visible';
     //T  }
     var i;
     var ids = new Array($ids);
     var evaluates = new Array($evaluates);
     if (document.forms['mform1'].type_assign.value==1) {
       document.forms['mform1'].automatic_evaluate.disabled=1;
       document.forms['mform1'].show_answer.disabled=1;
       document.forms['mform1'].automatic_evaluate.value=0;
       document.forms['mform1'].show_answer.value=0;
       }
     else {
       for (i=0;i<ids.length;i++) {
           if (ids[i]==id) {
              if (document.forms['mform1'].action.value=='edit') {
                 if (evaluates[i]==0) {
                   document.forms['mform1'].automatic_evaluate.style.display='none';
                   document.forms['mform1'].show_answer.style.display='none';
                   document.forms['mform1'].automatic_evaluate.disabled=1;
                   document.forms['mform1'].show_answer.disabled=1;
                   document.forms['mform1'].automatic_evaluate.value=0;
                   document.forms['mform1'].show_answer.value=0;
                   }
                 else {
                   document.forms['mform1'].automatic_evaluate.style.display='block';
                   document.forms['mform1'].show_answer.style.display='block';
                   document.forms['mform1'].automatic_evaluate.disabled=0;
                   document.forms['mform1'].show_answer.disabled=0;
                   document.forms['mform1'].automatic_evaluate.value=1;
                   document.forms['mform1'].show_answer.value=1;
                   }
              } // if (document.forms['mform1'].action.value=='edit')

              if (document.forms['mform1'].action.value=='add') {
                 if (evaluates[i]==0) {
                   document.forms['mform1'].automatic_evaluate.style.display='none';
                   document.forms['mform1'].show_answer.style.display='none';
                   document.forms['mform1'].automatic_evaluate.disabled=1;
                   document.forms['mform1'].show_answer.disabled=1;
                   document.forms['mform1'].automatic_evaluate.value=0;
                   document.forms['mform1'].show_answer.value=0;
                   }
                 else {
                   document.forms['mform1'].automatic_evaluate.style.display='block';
                   document.forms['mform1'].show_answer.style.display='block';
                   document.forms['mform1'].automatic_evaluate.disabled=0;
                   document.forms['mform1'].show_answer.disabled=0;
                   document.forms['mform1'].automatic_evaluate.value=1;
                   document.forms['mform1'].show_answer.value=1;
                   }
                 } // if (document.forms['mform1'].action.value=='add')
             } // if (ids[i]==id)
          } // for (i=0;i<ids.length;i++)
        }

      } // function config_ima(id)

   function disable_answer (resp) {
     if (resp==0) {
       document.forms['mform1'].show_answer.value=0;
       document.forms['mform1'].show_answer.disabled=1;
       }
     else {
       document.forms['mform1'].show_answer.disabled=0;
       }
      }
   function open_online_ima () {		
      ia_name = document.forms['mform1'].name.value;
      ia_file = document.getElementById('id_file_value').value;

      ia_ima = document.forms['mform1'].ia_ima_id.value;

      // Comentado por Luciano (30/03/2013): para introduzir 'ia_ima='+ia_ima
      // new_ima = window.open('$CFG->wwwroot/mod/ia/view.php?assign_id=$COURSE->assign_id&id=$COURSE->cm&action=editor&ia_name='+ia_name+'&ia_file='+ia_file,'','menubar=0,location=0,scrollbars,status,fullscreen,resizable');
      new_ima = window.open('$CFG->wwwroot/mod/ia/view.php?assign_id=$COURSE->assign_id&id=$COURSE->cm&action=editor&ia_ima='+ia_ima+'&ia_name='+ia_name+'&ia_file='+ia_file,'','menubar=0,location=0,scrollbars,status,fullscreen,resizable');
      }
   </script>";
   //-------------------------------------------------------------------------------
   /// Adding the "title_type_assign" fieldset, where all the common settings are showed

   $mform->addElement('header', 'title_type_assign',get_string('type_assign', 'ia') );
   $type_assign = array();
   $type_assign[1] = get_string('example', 'ia');
   $type_assign[2] = get_string('test', 'ia');
   $type_assign[3] = get_string('exercise', 'ia');

   $mform->addElement('select', 'type_assign', get_string('choose_type_activity', 'ia'), $type_assign,array('onChange'=>'config_type(this.value);'));
   $mform->setDefault('type_assign', 3); // default type_assign = 3
   $mform->setHelpButton('type_assign', array('type_assign', get_string('type_assign', 'ia'), 'ia'));

   //-------------------------------------------------------------------------------
   /// Adding the "data_activity" fieldset, where all the common settings are showed

   $mform->addElement('header', 'data_activity', get_string('data_activity', 'ia'));

   $mform->addElement('static', 'author', get_string('author_id', 'ia'));
   $mform->addElement('static', 'author_modified', get_string('author_id_modified', 'ia'));

  
   /// Adding the standard "name" field
   $mform->addElement('text', 'name', get_string('iatitle', 'ia'), array('size' => '55'));
   $mform->setType('name', PARAM_TEXT);
   $mform->addRule('name', get_string('required', 'ia'), 'required');

   /// Adding the standard "proposition" field
   $mform->addElement('htmleditor', 'proposition', get_string('proposition', 'ia'));
   $mform->setType('proposition', PARAM_RAW);

   $mform->setHelpButton('proposition', array('writing', 'questions', 'richtext'), false, 'editorhelpbutton');
   $mform->addRule('proposition', get_string('required', 'ia'), 'required');


   ///-----------------------------------------------------------------------------
   /// Adding the "interactivy_learning_module" fieldset, where all the common settings are showed
   $mform->addElement('header', 'interactivy_learning_module', get_string('interactivy_learning_module', 'ia')); 

   //$ynoptions = array( 0 => get_string('no'), 1 => get_string('yes'));
   // Search imas registered in the database
   $mas = search_iMA(1);

   $applets = array();
   foreach ($mas as $ma) // mount vector 'applets'
      $applets[$ma->id] = $ma->name;

   $ia_array=array();

   $ia_array[] =& $mform->createElement('select', 'ia_ima_id', get_string('choose_iMA', 'ia'), $applets,array('onChange'=>'config_ima(this.value);'));
   $ia_array[] =& $mform->createElement('button', 'online_new_ia', get_string('online_new_ia', 'ia'), array('onClick'=>'open_online_ima()'));
   $mform->addGroup($ia_array, 'select_ia', get_string('choose_iMA', 'ia'), array(' '), false);
   $mform->setHelpButton('select_ia', array('iMA', get_string('iMA', 'ia'), 'ia'));
		
		$mform->addElement('choosecoursefile', 'file', get_string('file', 'ia'), array('courseid' => $COURSE->id));
   $mform->setHelpButton('file', array('file', get_string('file', 'ia'), 'ia'));

   $mform->addRule('file', get_string('required', 'ia'), 'required', null, 'server');

   //Applies only iLM iGeom
    $mform->addElement('selectyesno', 'special_param1', get_string('script', 'ia')); //$ynoptions
    $mform->setDefault('special_param1', 0);
    $mform->setHelpButton('special_param1', array('special_param1', get_string('special_param1', 'ia'), 'ia'));

   ///-----------------------------------------------------------------------------
   //Applies only when the iLM is automatic evaluate.
   $mform->addElement('header', 'id_automatic_evaluate', get_string('only_automatic_evaluate', 'ia'));

   // Using automatic evaluation activity? 0 - no / 1 – yes
   $mform->addElement('selectyesno', 'automatic_evaluate', get_string('automatic_evaluate', 'ia'),array('onChange'=>'disable_answer(this.value);'));
   $mform->disabledif ('automatic_evaluate', 'type_assign', 'eq', 1); //activity does not display if the type example
   $mform->setDefault('automatic_evaluate', 0);
   $mform->setHelpButton('automatic_evaluate', array('automatic_evaluate', get_string('automatic_evaluate', 'ia'), 'ia'));


   //Show automatic evaluation results to students? 0 - no / 1 - yes
   $mform->addElement('selectyesno', 'show_answer', get_string('show_answer', 'ia'));
   $mform->disabledif ('show_answer', 'type_assign', 'eq', 1); //activity does not display if the type example
   // $mform->disabledif ('show_answer', 'automatic_evaluate', 'neq', 0);
   $mform->setDefault('show_answer', 0);
   //$mform->setHelpButton('show_answer', array('show_answer', get_string('show_answer', 'ia'), 'ia'));
 
   ///-----------------------------------------------------------------------------
   /// Adding the "duration_activity" fieldset, where all the common settings are showed
   $mform->addElement('header', 'duration_activity', get_string('duration_activity', 'ia'));

   //$mform->addElement('date_time_selector', 'timeavailable', get_string('availabledate', 'ia'), array('optional'=>true));
   $mform->addElement('date_time_selector', 'timeavailable', get_string('availabledate', 'ia'));
   $mform->setDefault('timeavailable', time());
   $mform->disabledif ('timeavailable', 'type_assign', 'eq', 1); ///activity does not display if the type example
   //$mform->addElement('date_time_selector', 'timedue', get_string('duedate', 'ia'), array('optional'=>true));
   $mform->addElement('date_time_selector', 'timedue', get_string('duedate', 'ia'));
   $mform->setDefault('timedue', time() + 7 * 24 * 3600);
   $mform->disabledif ('timedue', 'type_assign', 'eq', 1); //activity does not display if the type example
   //
   //  Allow sending late? 0 - no or unlocked / 1 - yes or locked
   $mform->addElement('selectyesno', 'preventlate', get_string('preventlate', 'ia'));
   $mform->setDefault('preventlate', 0);
   $mform->setHelpButton('preventlate', array('preventlate', get_string('preventlate', 'ia'), 'ia'));
   $mform->disabledif ('preventlate', 'type_assign', 'eq', 1); //activity does not display if the type example
   $mform->disabledif ('preventlate', 'type_assign', 'eq', 2); //activity does not display if the type test
   //Allow test after delivery? 0 - no or unlocked / 1 - yes or locked
   $mform->addElement('selectyesno', 'test', get_string('permission_test', 'ia'));
   $mform->setDefault('test', 0);
   $mform->setHelpButton('test', array('test', get_string('test_assign', 'ia'), 'ia'));
   $mform->disabledif ('test', 'type_assign', 'eq', 1); //activity does not display if the type example
   $mform->disabledif ('test', 'type_assign', 'eq', 2); //activity does not display if the type test
   ///--------------
   $mform->addElement('header', 'op_val', get_string('op_val', 'ia'));

   $mform->addElement('modgrade', 'grade', get_string('grade', 'ia'));
   $mform->setDefault('grade', 100);
   $mform->disabledif ('grade', 'type_assign', 'eq', 1); //activity does not display if the type example
   $mform->disabledif ('grade', 'type_assign', 'eq', 2); //activity does not display if the type test

   $max_experiment_options = array(0 => get_string('ilimit', 'ia'));
   for ($i = 1; $i <= 20; $i++) 
      $max_experiment_options[$i] = $i;

   $mform->addElement('select', 'max_experiment', get_string('experiment', 'ia'), $max_experiment_options);
   $mform->setDefault('max_experiment', 0);
   $mform->setHelpButton('max_experiment', array('max_experiment', get_string('max_experiment', 'ia'), 'ia'));
   $mform->disabledif ('max_experiment', 'type_assign', 'eq', 1); //activity does not display if the type example
   $mform->disabledif ('max_experiment', 'type_assign', 'eq', 2); //activity does not display if the type test

   if ($COURSE->assign_list) {
      ///-------------- dependency
      $mform->addElement('header', 'headerdependency', get_string('dependency', 'ia'));
      $mform->setHelpButton('headerdependency', array('dependency', get_string('dependency', 'ia'), 'ia'));

      foreach ($COURSE->assign_list as $assign) {
       $tmp = 'assign_list[' . $assign->id . ']';
       if ($assign->enable == 1)
           $mform->addElement('checkbox', $tmp, $assign->name);
      } //foreach ($COURSE->assign_list as $assign)
   } //if ($COURSE->assign_list)

   $mform->addElement('hidden', 'dependency');

   ///-------------- config
   $mform->addElement('header', 'config', get_string('general', 'ia'));
   $visibleoptions = array(1 => get_string('show'), 0 => get_string('hide'));

   $mform->addElement('select', 'visible', get_string('visible', 'ia'), $visibleoptions);
   $mform->setDefault('visible', 0);

   //-------------------------------------------------------------------------------
   // Hidden fields
   $mform->addElement('hidden', 'action');
   $mform->addElement('hidden', 'id');
   $mform->addElement('hidden', 'assign_id');
   $mform->addElement('hidden', 'ia_id');
   $mform->addElement('hidden', 'author_name');
   $mform->addElement('hidden', 'author_modified_name');
   $mform->addElement('hidden', 'timecreated');
   $mform->addElement('hidden', 'position');

   $mform->addElement('html', $code_javascript);

   // add standard elements, common to all modules
   $this->add_action_buttons();
   } // function definition()

 }

?>
