<?php

/** * @description Capability definitions for the ia module.
 *  * @author Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: access.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2010/12/21
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */

// The system has four possible values for a capability:
// CAP_ALLOW (Permitir)
// CAP_PREVENT (Evitar)
// CAP_PROHIBIT(Proibir)
// CAP_INHERIT (herdar)
//
// Hardening_new_Roles_system: http://docs.moodle.org/en/Development
/*
 * admin - Administrators can do anything at all courses.
 * coursecreator - Creators can create new courses to courses and act as teachers.
 * editingteacher - Teachers can do everything on a course, change, and evaluate activities.
 * teacher - Moderators can interact and evaluate but can not modify the activities.
 * student - Students usually have fewer privileges on a course.
 * guest - Guests have minimal privileges and can not publish texts.
 * user  - All users who login.
*/

$mod_ia_capabilities = array(
        'mod/ia:view' => array(
                'captype' => 'read',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'student' => CAP_ALLOW,
                        'teacher' => CAP_ALLOW,
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
        'mod/ia:editassign' => array(
                'captype' => 'write',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
        'mod/ia:evaluateassign' => array(
                'riskbitmask' => RISK_XSS,
                'captype' => 'write',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'teacher' => CAP_ALLOW,
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
        'mod/ia:viewassignall' => array(
                'captype' => 'read',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'teacher' => CAP_ALLOW,
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
            'mod/ia:viewreport' => array(
                'captype' => 'read',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'teacher' => CAP_ALLOW,
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
        'mod/ia:submitassign' => array(
                'captype' => 'write',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'student' => CAP_ALLOW
                )
        ),
        'mod/ia:deleteassignnull' => array(
               'riskbitmask' => RISK_XSS,
                'captype' => 'write',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'editingteacher' => CAP_ALLOW,
                        'coursecreator' => CAP_ALLOW,
                        'admin' => CAP_ALLOW
                )
        ),
        'mod/ia:deleteassignnotnull' => array(
                'riskbitmask' => RISK_XSS, 
                'captype' => 'write',
                'contextlevel' => CONTEXT_MODULE,
                'legacy' => array(
                        'admin' => CAP_ALLOW
                )
        ),
);

?>
