<?php

/** * @description This class provides all the functionality for an ia (interactive activities)
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão and Luciano Oliveira Borges
 *  * @version $Id: ia.class.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2011/11/16
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */


/**
 * Standard base class for all iAssign.
 */
class ia {
    var $cm;
    var $course;
    var $ia;
    var $strias;
    var $stria;
    var $context;
    var $assign_current;
    var $assign_up;
    var $assign_down;
    var $action;
    var $assign_submission_current;
    var $id_user_assign;
    var $bottonPost;
    var $write_solution;
    var $view_assign;
    var $icon_return;
    var $icon_home;
    var $icon_report;
    var $icon_correct;
    var $icon_incorrect;
    var $icon_feedback_correct;
    var $icon_feedback_incorrect;
    var $icon_nopost;
    var $icon_post;
    var $icon_test;
    var $icon_example;
    var $icon_print;
    var $icon_stats;
    var $icon_comment_open;
    var $icon_comment_close;
    var $icon_move_up;
    var $icon_move_down;
    var $icon_delete;
    var $icon_edit;
    var $icon_hide;
    var $icon_show;
    var $icon_ia;
    var $icon_add_assign;
    var $icon_repeat;
    var $hbar_blue;
    var $hbar_blue_r;
    var $hbar_red;
    var $hbar_red_r;
    var $hbar_green;
    var $hbar_green_r;
    var $hbar_orange;
    var $hbar_orange_r;

    
    /**
     * Constructor for the base ia class
     */
    function ia($ia, $cm, $course) {
        global $COURSE, $CFG,$USER;

        $botton = optional_param('botton',null);
        if (!is_null($botton))
            $USER->assignEdit =$botton;

        $this->id_user_assign = optional_param('id_user_assign', 0, PARAM_INT);
        $this->assign_current = optional_param('assign_current', 0, PARAM_INT);
        $this->assign_up = optional_param('assign_up', 0, PARAM_INT);
        $this->assign_down = optional_param('assign_down', 0, PARAM_INT);
        $this->assign_submission_current = optional_param('assign_submission_current', 0, PARAM_INT);
        $this->write_solution = optional_param('write_solution', 0, PARAM_INT);

        //action:
        //up - move up activity (mover atividade para cima)
        //down - move down activity (mover atividade para baixo)
        //visible - view/hide activity (exibir/ocultar atividade)
        //delete - delete activity (excluir atividade)
        //deleteyes - confirms exclusion of activity (confirma exclusão de atividade)
        //deleteno - does not erase activity (não apaga atividade)
        //add - add activity (adicionar atividade)
        //edit - edit activity (modificar atividade)

        $this->action = optional_param('action', NULL);

        if ($cm) {
            $this->cm = $cm;
        } elseif (!$this->cm = get_coursemodule_from_id('ia', $cmid)) {
            error('Course Module ID was incorrect');
        } //if ($cm)

        if ($course) {
            $this->course = $course;
        } elseif ($this->cm->course == $COURSE->id) {
            $this->course = $COURSE;
        } elseif (!$this->course = get_record('course', 'id', $this->cm->course)) {
            error('Course is misconfigured');
        } //if ($course)
        if ($ia) {
            $this->ia = $ia;
        } elseif (!$this->ia = get_record('ia', 'id', $this->cm->instance)) {
            error('ia ID was incorrect');
        } //if ($ia)
        $this->context = get_context_instance(CONTEXT_MODULE, $this->cm->id);
        $this->stria = get_string('modulename', 'ia');
        $this->strias = get_string('modulenameplural', 'ia');
        $this->return = $CFG->wwwroot . "/mod/ia/view.php?id=" . $this->cm->id;
        $this->bottonPost = 0;
        $this->view_assign = optional_param('action', false);
        $this->insert_icons();
    }

    /**
     * Display the iAssign, used by view.php
     *
     * This in turn calls the methods producing individual parts of the page
     */
    function view() {
        global $USER;
        require_capability('mod/ia:view', $this->context);
        add_to_log($this->course->id, "ia", "view", "view.php?id={$this->cm->id}", $this->ia->name, $this->cm->id, $USER->id);

        if ($this->action) {
            if (has_capability('mod/ia:editassign', $this->context, $USER->id))
                $this->action_assign_restricted();
            elseif (has_capability('mod/ia:evaluateassign', $this->context, $USER->id)){
                $this->action_assign_limit();
            }else
                $this->action_assign();
        }
        else {
            $this->view_header($title = NULL);
            $this->view_assigns();
            $this->view_footer();
        } //if ($this->action)

        //security: delete all records with an error loading IMA
        delete_records("ia_assign_security", "user_id", $USER->id,"view", 1);
    }

    /**
     * Display the header of page
     */
    function view_header($title) {
        global $CFG, $COURSE;
        $course=$this->course->id;
        $id = $this->cm->id;
        $navlinks = array();
        $navlinks[] = array('name' => $this->strias, 'link' => "index.php?id=$course", 'type' => 'activity');
        if (is_null($title)) {
            $navlinks[] = array('name' => format_string($this->ia->name), 'link' => "view.php?id=$id", 'type' => 'activityinstance');
        } else {
            $navlinks[] = array('name' => format_string($this->ia->name), 'link' => "view.php?id=$id", 'type' => 'activityinstance');
            $navlinks[] = array('name' => $title, 'link' =>"", 'type' => 'activityinstance');
        } //if (is_null($title))
        $navigation = build_navigation($navlinks);
        print_header_simple(format_string($this->ia->name), "", $navigation, "", "", true);
    }

    /**
     * Limited access
     */
    function action_assign_restricted() {

        switch ($this->action) {
            case 'up':
                $this->move_assign($this->assign_current, $this->assign_up);
                break;
            case 'down':
                $this->move_assign($this->assign_current, $this->assign_down);
                break;
            case 'visible':
                $this->visible_assign();
                break;
            case 'delete':
                $this->delete_assign();
                break;
            case 'deleteno':
                $this->delete_assign();
                break;
            case 'deleteyes':
                $this->delete_assign();
                break;
            case 'add':
                $this->add_edit_assign();
                break;
            case 'edit':
                $this->add_edit_assign();
                break;
            case 'view':
                $this->view_assign_current();
                break;
            case 'newcomment':
                $this->write_comment_submission();
                break;
            case 'viewsubmission':
                $this->view_assign_current();
                break;
            case 'edit_status':
                $this->edit_status();
                break;
            case 'edit_grade':
                $this->edit_grade();
                break;
            case 'get_answer':
                $this->get_answer();
                break;
            case 'report':
                $this->report();
                break;
            case 'print':
                $this->report();
                break;
            case 'stats':
                $this->stats();
                break;
            case 'printstats':
                $this->stats();
                break;
            case 'editor':
                $this->ima_editor();
                break;
        } //switch ($this->action)
        redirect($this->return);
    }

    /**
     * Limited access role monitor
     */
    function action_assign_limit() {

        switch ($this->action) {

            case 'view':
                $this->view_assign_current();
                break;
            case 'newcomment':
                $this->write_comment_submission();
                break;
            case 'viewsubmission':
                $this->view_assign_current();
                break;
            case 'edit_status':
                $this->edit_status();
                break;
            case 'edit_grade':
                $this->edit_grade();
                break;
            case 'report':
                $this->report();
                break;
            case 'print':
                $this->report();
                break;
            case 'stats':
                $this->stats();
                break;
            case 'printstats':
                $this->stats();
                break;
            case 'editor':
                $this->ima_editor();
                break;
        } //switch ($this->action)
        redirect($this->return);
    }



    /**
     * Access interactive activities
     */
    function action_assign() {
        switch ($this->action) {
            case 'view':
                $this->view_assign_current();
                break;
            case 'repeat':
                $this->view_assign_current();
                break;
            case 'newcomment':
                $this->write_comment_submission();
                break;
            case 'get_answer':
                $this->get_answer();
                break;
            case 'overwrite':
                $this->get_answer();
                break;
            case 'stats_student':
                $this->stats_students();
                break;
        } //switch ($this->action)
        redirect($this->return);
    }

    /**
     * Insertion of icons
     */
    function insert_icons () {
        global $CFG;
        $this->icon_return = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/return.gif" alt="' . get_string('return_home_course', 'ia') . '"/>';
        $this->icon_report = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/report.gif" alt="alt="' . get_string('view_report', 'ia') . '" />';
        $this->icon_correct = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/correct.gif" alt="' . get_string('correct', 'ia') . '" />';
        $this->icon_incorrect = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/incorrect.gif" alt="' . get_string('incorrect', 'ia') . '" />';
        $this->icon_nopost = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/nopost.gif" alt="' . get_string('not_post', 'ia') . '" />';
        $this->icon_post = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/post.gif" alt="' . get_string('post', 'ia') . '" />';
        $this->icon_test = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/test.gif" alt="' . get_string('test', 'ia') . '" />';
        $this->icon_example = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/example.gif" alt="' . get_string('example', 'ia') . '" />';
        $this->icon_print = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/print.gif" alt="' . get_string('print', 'ia') . '" />';
        $this->icon_comment_open = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/comment_open.gif" alt="' . get_string('no_new_comment', 'ia') . '" />';
        $this->icon_comment_close = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/comment_close.gif" alt="' . get_string('new_comment', 'ia') . '" />';
        $this->icon_move_up = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/up.gif" alt="' . get_string('move_up_assign', 'ia') . '" />';
        $this->icon_move_up_disable = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/up_disable.gif" alt="" />';
        $this->icon_move_down = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/down.gif" alt="' . get_string('move_down_assign', 'ia') . '" />';
        $this->icon_move_down_disable = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/down_disable.gif" alt="" />';
        $this->icon_move_left = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/left.gif" alt="" />';
        $this->icon_move_left_disable = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/left_disable.gif" alt="" />';
        $this->icon_move_right = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/right.gif" alt="" />';
        $this->icon_move_right_disable = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/right_disable.gif" alt="" />';
        $this->icon_delete = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/delete.gif" alt="' . get_string('delete_assign', 'ia') . '" />';
        $this->icon_edit = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/edit.gif" alt="' . get_string('edit_assign', 'ia') . '" />';
        $this->icon_hide = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hide.gif" alt="' . get_string('hide_assign', 'ia') . '" />';
        $this->icon_show = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/show.gif" alt="' . get_string('show_assign', 'ia') . '" />';
        $this->icon_ia = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/icon.gif" alt="' . get_string('stria', 'ia') . '" />';
        $this->icon_add_assign = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/add_assign.gif" alt="' . get_string('add_assign', 'ia') . '" />';
        $this->icon_feedback_incorrect = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/feedback_incorrect.gif" alt="' . get_string('incorrect', 'ia') . '" />';
        $this->icon_feedback_correct = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/feedback_correct.gif" alt="' . get_string('correct', 'ia') . '" />';
        $this->icon_repeat = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/repeat.gif" alt="' . get_string('repeat', 'ia') . '" />';
        $this->icon_home = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/home.gif" alt="' . get_string('repeat', 'ia') . '" />';
        $this->icon_stats = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/stats.gif" alt="' . get_string('repeat', 'ia') . '" />';
        $this->hbar_blue = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_blue.gif"/>';
        $this->hbar_blue_r = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_blue_r.gif"/>';
        $this->hbar_red = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_red.gif"/>';
        $this->hbar_red_r = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_red_r.gif"/>';
        $this->hbar_green = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_green.gif"/>';
        $this->hbar_green_r = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_green_r.gif"/>';
        $this->hbar_orange = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_orange.gif"/>';
        $this->hbar_orange_r = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/hbar_orange_r.gif"/>';
    }


    /**
     * receives the return of iLM
     */
    function get_answer () {
        global $USER, $CFG;
        $id = $this->cm->id;

         //receives data of current activity
        $ia_assign = get_record("ia_assign", "id", $this->assign_current);

        //receives data of iLM using the current activity
        $ia_ima = get_record("ia_ima", "id", $ia_assign->ia_ima_id);

        //receives data of submission of current activity
        $ia_assign_submissions = get_record("ia_assign_submissions", "ia_assign_id", $this->assign_current, "user_id", $this->id_user_assign); // data about student solution
 
        //receives post and get
        $MA_POST_Value = optional_param('MA_POST_Value'); // 1 - activity evaluated as correct  / 0 -  activity evaluated as incorrect
        $MA_POST_Archive = optional_param('MA_POST_Archive'); //answer file (string)
        $MA_POST_Info = optional_param('MA_POST_Info');
        $MA_POST_SystemData = optional_param('MA_POST_SystemData');
        $return_get_answer = optional_param('return_get_answer', 0);

        //feedback
        /*
          status of activities:
          0 – not post
          1 – post
          2 – evaluated as incorrect
          3 – evaluated as correct
         */

        $title = get_string('evaluate_assign', 'ia');
        $this->view_header($title);
        print_simple_box_start('center');
        $return = "" . $CFG->wwwroot . "/mod/ia/view.php?action=view&id=" . $id . "&assign_submission_current=" . $this->assign_submission_current . "&id_user_assign=" . $this->id_user_assign . "&assign_current=" . $this->assign_current;
        $return_last = "&nbsp;<a href='" . $return . "'>" . $this->icon_return . '&nbsp;' . get_string('return_assign', 'ia') . "</a>";
        $link_return = "&nbsp;<a href='" . $this->return . "'>" . $this->icon_home . '&nbsp;' . get_string('activities_page', 'ia') . "</a>";
        echo '<table  width=100% >';

        if ($MA_POST_Archive == -1 or empty ($MA_POST_Archive)) { // if ($MA_POST_Value == -1) {
            $this->write_solution = 0; // necessary in order to take note in Moodle 'grade' system
            echo '<tr><td colspan=2><br>' . get_string('empty_answer_post', 'ia') . '</td>';
        } else {
            if ($ia_ima->evaluate == 1 and $ia_assign->automatic_evaluate == 1) { // iLM with automatic evaluator

                if (intval($MA_POST_Value) == 1) {
                    $status = 3;
                    $grade_student = $ia_assign->grade; // evaluated as correct solution submitted is assigned the note pattern of activity
                    $msg = '<tr><td colspan=2>' . $this->icon_feedback_correct . '<br>' . get_string('get_answer_correct', 'ia') . '</td>';
                  } else {
                    $status = 2;
                    $grade_student = 0; // evaluated as incorrect solution
                    $msg = '<tr><td colspan=2>' . $this->icon_feedback_incorrect . '<br>' . get_string('get_answer_incorrect', 'ia') . '</td>';
                  } // if ($MA_POST_Value == 1)

                if ($ia_assign->show_answer == 0) { //not automatic evaluate
                   echo '<tr><td width=60% ><strong>' . $this->icon_post . get_string('get_answer', 'ia') . '</strong></td>';
                   echo '<tr><td width=40% align=right>' . $return_last . '&nbsp;' . $link_return . '</td></tr>';
                   echo '<tr>';
                } else {
                  echo '<tr><td width=60% ><strong>' . get_string('auto_result', 'ia') . '</strong></td>';
                  echo '<td width=40% align=right>' . $return_last . '&nbsp;' . $link_return . '</td></tr>';
                  echo '<tr>';
                  echo   $msg;
 
                }

            } else {
                $status = 1;
                $grade_student = 0; // iLM not have automatic evaluator
                echo '<tr><td colspan=2>' . $this->icon_post .  get_string('get_answer_post', 'ia') . '</td>';
                echo '<tr><td width=40% align=right>' . $return_last . '&nbsp;' . $link_return . '</td></tr>';
                echo '<tr>';
            } //if ($ia_ima->evaluate == 1)
        } //if ($MA_POST_Value == -1)
        echo '</tr></table>';

        print_simple_box_end();

        // add or update evaluate
        if ($this->write_solution == 1) {
            $timenow = time();

            //new record
            if (!$ia_assign_submissions) {
                $newentry->user_id = $this->id_user_assign;
                $newentry->ia_assign_id = $ia_assign->id;
                $newentry->timecreated = $timenow;
                $newentry->timemodified = $timenow;
                $newentry->answer = $MA_POST_Archive;
                $newentry->grade = $grade_student;
                $newentry->status = $status;
                $newentry->experiment = 1;
                
                if (!$newentry->id = insert_record("ia_assign_submissions", $newentry)) {
                    error(get_string('error_insert', 'ia'));
                } else {
                    add_to_log($this->course->id, "ia", "add submission", "view.php?id={$this->ia->id}", $ia_assign->name, $this->cm->id, $USER->id);
                    $this->update_grade_student($newentry->user_id, $newentry->ia_assign_id, $this->ia->id);
                }
            } elseif ($ia_assign_submissions->status != 3) {
                $newentry->id = $ia_assign_submissions->id;
                $newentry->ia_assign_id = $ia_assign_submissions->ia_assign_id;
                $newentry->user_id = $ia_assign_submissions->user_id;
                $newentry->timecreated = $ia_assign_submissions->timecreated;
                $newentry->timemodified = $timenow;
                $newentry->answer = $MA_POST_Archive;
                $newentry->grade = $grade_student;
                $newentry->status = $status;
                $newentry->experiment = $ia_assign_submissions->experiment + 1;
                if (!update_record("ia_assign_submissions", $newentry)) {
                    error(get_string('error_update', 'ia'));
                    //D depurar...
                    //D $stringAux = "ia.class.php: ".$MA_POST_Archive."<br/> ".utf8_encode($MA_POST_Archive)."<br/>".utf8_encode(utf8_encode($MA_POST_Archive))."<br/>";
                    //D $fp = fopen("teste1.txt","w");
                    //D fwrite($fp,$stringAux);
                } else {
                    add_to_log($this->course->id, "ia", "update submission", "view.php?id={$this->ia->id}", $ia_assign->name, $this->cm->id, $USER->id);
                    $this->update_grade_student($newentry->user_id, $newentry->ia_assign_id, $this->ia->id);
                }
            } else {
                if ($return_get_answer == 1) {
                    $newentry->id = $ia_assign_submissions->id;
                    $newentry->ia_assign_id = $ia_assign_submissions->ia_assign_id;
                    $newentry->user_id = $ia_assign_submissions->user_id;
                    $newentry->timecreated = $ia_assign_submissions->timecreated;
                    $newentry->timemodified = $timenow;
                    $newentry->answer = $MA_POST_Archive;
                    $newentry->grade = $grade_student;
                    $newentry->status = $status;
                    $newentry->experiment = $ia_assign_submissions->experiment + 1;
                    if (!update_record("ia_assign_submissions", $newentry))
                        error(get_string('error_update', 'ia'));
                    else {
                        add_to_log($this->course->id, "ia", "update submission", "view.php?id={$this->ia->id}", $ia_assign->name, $this->cm->id, $USER->id);
                        $this->update_grade_student($newentry->user_id, $newentry->ia_assign_id, $this->ia->id);
                        print_simple_box_start("center");
                        echo "<p>" . get_string('assign_update', 'ia') . "</p>";
                        print_simple_box_end();
                    }
                } elseif ($return_get_answer == 2) {
                    print_simple_box_start("center");
                    echo "<p>" . get_string('assign_cancel', 'ia') . "</p>";
                    print_simple_box_end();
                } else {
                    print_simple_box_start("center");
                    echo "
                 <script>
                 function overwrite() {
	           document.formEnvio.return_get_answer.value = 1;
	           document.formEnvio.submit();
                 }
                 function nooverwrite() {
	           document.formEnvio.return_get_answer.value = 2;
	           document.formEnvio.submit();
                 }
                 </script>";
                    $param_aux = "action=overwrite&assign_submission_current=" . $ia_assign_submissions->id . "&id=" . $id . "&assign_current=" . $this->assign_current . "&write_solution=" . $this->write_solution . "&id_user_assign=" . $USER->id;
                    $get_answer_overwrite = $CFG->wwwroot . "/mod/ia/view.php?" . $param_aux;
                    echo "<form name='formEnvio' method='post' action='$get_answer_overwrite' enctype='multipart/form-data'>";
                    echo "<p>" . get_string('last_assign_correct', 'ia') . "</p>";
                    echo "<p>" . get_string('update_assign', 'ia') . "</p>";
                    echo "<input type='hidden' name='MA_POST_Archive' value='$MA_POST_Archive'/>
                  <input type='hidden' name='MA_POST_Value' value='$MA_POST_Value'/>
                  <input type='hidden' name='MA_POST_Info' value='$MA_POST_Info'/>
                  <input type='hidden' name='MA_POST_SystemData' value='$MA_POST_SystemData'/>
                  <input type='hidden' name='return_get_answer'/> ";
                    echo "<input type=button value='" . get_string('yes', 'ia') . "' onClick = 'overwrite()'
                      title='" . get_string('message_update_assign', 'ia') . "'/>&nbsp;&nbsp;";
                    echo "<input type=button value='" . get_string('no', 'ia') . "' onClick = 'nooverwrite()'
                      title='" . get_string('message_no_update_assign', 'ia') . "'/>";
                    echo" </form>";
                    print_simple_box_end();
                }
            }
        } //if ($this->write_solution == 1)
        $this->view_footer();
        die;
    }

    /**
     * Editing status of interactive activities
     */
    function edit_status() {
        global $USER;

        $newentry->id = $this->assign_submission_current;
        $newentry->status = optional_param('return_status', 0);

        $assign_submission = get_record('ia_assign_submissions', 'id', $this->assign_submission_current);
        if ($assign_submission->status != 0 and $newentry->status == 0)
            $newentry->status = $assign_submission->status;

        $newentry->teacher = $USER->id;
        if (!update_record('ia_assign_submissions', $newentry))
            error(get_string('error_update', 'ia'));
        else {
            add_to_log($this->course->id, "ia", "update", "view.php?id={$this->ia->id}", $newentry->id, $this->cm->id, $USER->id);
            $this->action = 'viewsubmission';
            $this->view_assign_current();
        } //if (!update_record('ia_assign_submissions', $newentry))
    }

    /**
     * Editing grade of interactive activities
     */
    function edit_grade() {
        global $USER;
        $newgrade = optional_param('return_grade', 0);
        if ($newgrade and $newgrade >= 0) {
            $newentry->id = $this->assign_submission_current;
            $newentry->grade = optional_param('return_grade', 0);
            $newentry->teacher = $USER->id;
            if (!update_record('ia_assign_submissions', $newentry))
                error(get_string('error_update', 'ia'));
            else 
                add_to_log($this->course->id, "ia", "update", "view.php?id={$this->ia->id}", $newentry->id, $this->cm->id, $USER->id);
         } //if ($newgrade >= 0)
        $this->action = 'viewsubmission';
        $this->view_assign_current();
    }

    /**
     * Changes position within of interactive group activity
     */
    function move_assign($source, $target) {
        $ia_assign_source = get_record("ia_assign", "id", $source);
        $ia_assign_target = get_record("ia_assign", "id", $target);
        $aux = $ia_assign_source->position;
        $newentry->id = $ia_assign_source->id;
        $newentry->position = $ia_assign_target->position;
        if (!update_record('ia_assign', $newentry)) 
            error(get_string('error_update_move_assign', 'ia'));

        $newentry->id = $ia_assign_target->id;
        $newentry->position = $aux;
        if (!update_record('ia_assign', $newentry)) 
            error(get_string('error_update_move_assign', 'ia'));
    }


    /**
     * Enable or disable the display of interactive activities
     */
    function visible_assign() {
        $ia_assign_current = get_record("ia_assign", "id", $this->assign_current);
        if ($ia_assign_current->visible == 0)
            $ia_assign_visible = 1;
        else
            $ia_assign_visible=0;

        $newentry->id = $ia_assign_current->id;
        $newentry->visible = $ia_assign_visible;
        if (!update_record('ia_assign', $newentry))
            error(get_string('error_update_visible_assign', 'ia'));
    }

    /**
     * Delete interactive activities
     */
    function delete_assign() {
        global $USER, $CFG;
        $id = $this->cm->id;
        $ia_id = $this->ia->id;
        $this->view_header($title = NULL);
        $ia_assign_current = get_record("ia_assign", "id", $this->assign_current);

        $ia_assign_submissions_current = get_records("ia_assign_submissions ", "ia_assign_id", $this->assign_current);

        $ia_assign_name = $ia_assign_current->name;
        if ($this->action == 'delete') {
            print_simple_box_start("center");
            echo "<p>" . get_string('delete_activity', 'ia') . "&nbsp;<strong>" . $ia_assign_current->name . "</strong></p>";
            if ($ia_assign_submissions_current) {
                echo "<p>" . get_string('number_submissions', 'ia') . "&nbsp;<strong>" . count($ia_assign_submissions_current) . "</strong></p>";
                if (!has_capability('mod/ia:deleteassignnotnull', $this->context, $USER->id)) {
                    print_box_end();
                    $this->return_home_course('delete_activity_permission_adm');
                } //if (!has_capability('mod/ia:deleteassignnotnull', $this->context, $USER->id))
            } // if ($ia_assign_submissions_current)
            else
                echo "<p>" . get_string('not_submissions_activity', 'ia') . "</p>";
            echo '<table width=50% border=0 valign="top">';
            echo '<tr><td>';
            echo "<p>" . get_string('what_do', 'ia') . "</p>";
            echo '</td><td>';

            $bottonDelete_yes = get_string('delete_assign', 'ia');
            $deleteAssignyes = $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=deleteyes&assign_current=" . $this->assign_current ;
            echo "<form name='formDelete' id='formDelete' method='post' action='$deleteAssignyes' enctype='multipart/form-data'>";
            echo " <input type=submit value='$bottonDelete_yes'/>\n";
            echo "</form>\n";
            echo "</td><td>\n";
            $bottonDelete_no = get_string('delete_cancel', 'ia');
            $deleteAssignno = $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=deleteno&assign_current=" . $this->assign_current ;
            echo "<form name='formDelete' id='formDelete' method='post' action='$deleteAssignno' enctype='multipart/form-data'>\n";
            echo " <p><input type=submit value='$bottonDelete_no'/></p>\n";
            echo "</form>\n";
            echo "</td></tr></table>\n";
            print_simple_box_end();
            /// Finish the page
            $this->view_footer();
            die;
        } //if ($this->action == 'delete')
        if (($this->action == 'deleteyes') and (has_capability('mod/ia:deleteassignnull', $this->context, $USER->id))) {
            if ($ia_assign_submissions_current) {
                foreach ($ia_assign_submissions_current as $assign_submissions) 
                    $delete_ia_assing_submissions_comment = delete_records('ia_assign_submissions_comment', 'submission_id', $assign_submissions->id);

            } // if ($ia_assign_submissions_current)
            $delete_assign_submissions_current = delete_records("ia_assign_submissions ", "ia_assign_id", $this->assign_current);
            if (delete_records('ia_assign', 'id', $this->assign_current)) {
                add_to_log($this->course->id, "ia", "delete assign", "view.php?id=$id", "$ia_assign_name", $this->cm->id, $USER->id);
                $this->update_grade_ia($ia_id);
                $this->return_home_course('confirm_delete_assign');
            } // if (delete_records('ia_assign', 'id', $this->assign_current))
            else
                $this->return_home_course('error_confirm_delete_assign');
        } //if (($this->action == 'deleteyes') and (has_capability('mod/ia:deleteassignnull', $this->context, $USER->id)))
        if ($this->action == 'deleteno') 
            $this->return_home_course('confirm_not_delete_assign');
       
    }

    /**
     * Add or Edit interactive activities
     */
    function add_edit_assign() {
        global $USER, $CFG, $COURSE;
        $id = $this->cm->id;
        $COURSE->cm=$id;
        require_once('assign_form.php');
        $ia_id = $this->ia->id;
        $return = $this->return;
        $param = new object();
        $param->action = $this->action; // oculto
        $param->id = $id; // oculto
        $COURSE->assign_id = $this->assign_current;
        if ($this->action == 'add') {
            
           /* show only activities like exercise
              $ia_assign =get_records_sql ("SELECT s.id, s.name, s.dependency
              FROM {$CFG->prefix}ia_assign s
              WHERE s.ia_id = '$ia_id'
              AND s.type_assign=3
              ORDER BY `s`.`name` ASC");
            */

            $ia_assign = get_records_sql("SELECT s.id, s.name, s.dependency
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia_id'
                             ORDER BY `s`.`position` ASC");

            $title = get_string('add_ia', 'ia');
            $param->ia_id = $ia_id;
            $param->name = "";
            $param->type_assign = 3;
            $param->proposition = "";
            $author = get_record("user", 'id', $USER->id);
            $param->author_name = $author->firstname . '&nbsp;' . $author->lastname;
            $param->author_modified_name = $author->firstname . '&nbsp;' . $author->lastname;
            $param->author = $param->author_name;
            $param->author_modified = $param->author_modified_name;
            $COURSE->assign_list = array();
            $param->assign_list = array();
            if ($ia_assign){
            foreach ($ia_assign as $assign) {
                $param->assign_list[$assign->id] = 0;
                $COURSE->assign_list[$assign->id]->id=$assign->id;
                $COURSE->assign_list[$assign->id]->name = $assign->name;
                $COURSE->assign_list[$assign->id]->enable =1;
            } //foreach ($ia_assign as $assign)
            }
            //else
             //   $param->assign_list[-1] = 0;
            $param->ia_ima_id = 0;
            $param->file = "";
            $param->grade = 100;
            $param->timemodified = time();
            $param->timecreated = time();
            $param->timeavailable = time();
            $param->timedue = time() + 7 * 24 * 3600;
            $param->preventlate = 0;
            $param->test = 0;
            $param->special_param1 = 0;
            $param->visible = 1;
            $param->max_experiment = 0;
            $param->dependency=0;
            $param->automatic_evaluate=1;
            $param->show_answer=1;
        }  // if ($this->action == 'add')
        elseif ($this->action == 'edit') {
            $title = get_string('edit_ia', 'ia');
            $COURSE->assign_list = array();

            if (!empty ($this->assign_current)){
            
            
            $ia_assing_current = get_record('ia_assign', 'id', $this->assign_current);

                 /*
              $ia_assign =get_records_sql ("SELECT *
              FROM {$CFG->prefix}ia_assign s
              WHERE s.ia_id = '$ia_id'
              AND s.type_assign=3
              AND s.id!='$ia_assing_current->id'
              ORDER BY `s`.`name` ASC");
             *
             */

            $ia_assign = get_records_sql("SELECT *
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia_id'
                             AND s.id!='$ia_assing_current->id'
                             ORDER BY `s`.`position` ASC");

            $param->assign_id = $ia_assing_current->id; // oculto
            $param->ia_id = $ia_assing_current->ia_id; // oculto
            $param->name = $ia_assing_current->name;
            $param->type_assign = $ia_assing_current->type_assign;
            $param->proposition = $ia_assing_current->proposition;
            $param->author_name = $ia_assing_current->author_name; // oculto
            $param->author = $ia_assing_current->author_name;

            $author = get_record("user", 'id', $USER->id);
            $param->author_modified_name = $author->firstname.'&nbsp;'.$author->lastname;
            $param->author_modified = $param->author_modified_name;

            $dependency = explode(';', $ia_assing_current->dependency);

            $param->assign_list = array();

            $inter = array();
            if ($ia_assign)
            foreach ($ia_assign as $assign)
                if (in_array($assign->id, $dependency))
                    $inter[] = $assign->id;

            $ia_assign_dependency = get_records_sql("SELECT *
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia_id'
                             AND s.id!='$ia_assing_current->id'
                             AND s.dependency!=0");
            $array_dependency=array();

            $subdependency="";
            $sub_subdependency="";
            //dependent on this exercise
            if ($ia_assign_dependency){
              $subdependency .= $this->search_dependency($ia_assing_current->id, $ia_assign_dependency);
       
            //to whom this exercise depends
            foreach ($inter as $tmp)
                $sub_subdependency .=$this->search_sub_dependency($tmp);

            $list_dependency = $subdependency . $sub_subdependency;
            $array_dependency = explode(";", $list_dependency);
            }

            if ($ia_assign){
            foreach ($ia_assign as $assign) {
                $COURSE->assign_list[$assign->id]->name = $assign->name;
                $COURSE->assign_list[$assign->id]->id = $assign->id;

                if (in_array($assign->id, $dependency))
                    $param->assign_list[$assign->id] = 1;
                else
                    $param->assign_list[$assign->id] = 0;

                if (in_array($assign->id, $array_dependency))
                    $COURSE->assign_list[$assign->id]->enable = 0;
                else
                    $COURSE->assign_list[$assign->id]->enable = 1;

            } // foreach ($ia_assign as $assign)
            }
            $param->ia_ima_id = $ia_assing_current->ia_ima_id;
            $param->file = $ia_assing_current->file;
            $param->grade = $ia_assing_current->grade;
            $param->timecreated = $ia_assing_current->timecreated; // oculto
            $param->timeavailable = $ia_assing_current->timeavailable;
            $param->timedue = $ia_assing_current->timedue;
            $param->preventlate = $ia_assing_current->preventlate;
            $param->test = $ia_assing_current->test;
            $param->special_param1 = $ia_assing_current->special_param1;
            $param->position = $ia_assing_current->position; // oculto
            $param->visible = $ia_assing_current->visible;
            $param->max_experiment = $ia_assing_current->max_experiment;
            $param->automatic_evaluate=$ia_assing_current->automatic_evaluate;
            $param->show_answer=$ia_assing_current->show_answer;
        } //elseif ($this->action == 'edit')
        }
        //search position
        $assign_list = get_records_list('ia_assign', 'ia_id', $ia_id, 'position ASC');

        if ($assign_list) {
            $end_list = array_pop($assign_list);
            $param->position = $end_list->position + 1;
        } //if ($assign_list)
        else
            $param->position = 1;
       
        $this->view_header($title);
        
        $mform = new mod_assign_form();
        $mform->set_data($param);
        $result = $mform->get_data();
         
        if ($mform->is_cancelled()) {
            if ($mform->get_data())
                $this->assign_current=$result->assign_id;
            $this->return_home_course('assign_cancel');
        } elseif ($mform->get_data()) {
     
       if ($result->type_assign==1 or $result->type_assign==2)
          $result->grade=0;

            if ($result->type_assign==1){
                    $result->automatic_evaluate=0;
                    $result->show_answer=0;
            }elseif ($result->automatic_evaluate==0)
                    $result->show_answer=0;

           // if ($_POST['assign_list'])
                $result->assign_list = optional_param('assign_list', NULL);//$_POST['assign_list'];

            if ($result->assign_list) {
                foreach ($result->assign_list as $key => $value)
                    $result->dependency.=$key . ';';

            } //if ($result_assign_list)
            else
                $result->dependency = 0;



            if (!empty($result->file)) {

                // check whether of uploaded file extension gives
                $ia_ima=get_record('ia_ima','id',$result->ia_ima_id);
                $file = explode('.', $result->file);
                if ($ia_ima->extension != $file[1]) {

                    print_simple_box_start('center');
                    echo '<table width=100% border=0 valign="top">';
                    echo '<tr><td align="center"><font color=red>';
                    print_string('incompatible_extension_file', 'ia');

                    echo '</font></td></tr></table>';
                    print_simple_box_end();
                   // $USER->assign_id=$result->assign_id;
                    $mform->display();

                } //if ($ia_ima->extension != $file[1])
                else {

                    if ($this->action == 'add') {
                        $this->new_assign($result);
                        add_to_log($this->course->id, "ia", "add", "view.php?id=$id", $result->name, $this->cm->id, $USER->id);
                        $this->return_home_course('assign_add');
                    } //if ($this->action == 'add')
                    elseif ($this->action == 'edit') {
                        $this->update_assign($result);
                        add_to_log($this->course->id, "ia", "update", "view.php?id=$id", $result->name, $this->cm->id, $USER->id);
                        $this->return_home_course('assign_update');
                    } //elseif ($this->action == 'edit')
                } //if ($ia_ima->extension != $file[1])
            } // if (!empty($result->file))
            else {
                print_simple_box_start('center');
                echo '<table width=100% border=0 valign="top">';
                echo '<tr><td align="center"><font color=red>';
                print_string('required_file', 'ia');
                echo '</font></td></tr></table>';
                print_simple_box_end();
                $mform->display();
            } // if (!empty($result->file))
        } //elseif ($mform->get_data())
        else
            $mform->display();
        $this->view_footer();
        die;
    }

    /**
     * Search dependency
     */
    function search_dependency($search_assing_id, $ia_assign) {
        $dependency = "";
        if ($ia_assign)
        foreach ($ia_assign as $assign) {
            $inter_dependency = explode(';', $assign->dependency);
            if (in_array($search_assing_id, $inter_dependency)) {
                $dependency .=$assign->id . ";";
                $dependency .= $this->search_dependency($assign->id, $ia_assign);
            } // if (in_array($search_assing_id, $inter_dependency))
        } //foreach ($ia_assign as $assign)
        return $dependency;
    }

   /**
     * Search subdependency
     */
    function search_sub_dependency($search_assing_id) {
        $ia_assign = get_record('ia_assign', 'id', $search_assing_id);
        $dependency = "";
        if ($ia_assign) {
            $inter_dependency = explode(';', $ia_assign->dependency);

            foreach ($inter_dependency as $tmp) {
                if ($tmp != 0)
                    $dependency .=$tmp . ";";
                $dependency .= $this->search_sub_dependency($tmp);
            } //foreach ($inter_dependency as $tmp)
        } //if ($ia_assign)
        return $dependency;
    }

    /**
     * Add news interactive activities
     */
    function new_assign($param) {
        $newentry->ia_id = $param->ia_id;
        $newentry->name = $param->name;
        $newentry->type_assign = $param->type_assign;
        $newentry->proposition = $param->proposition;
        $newentry->author_name = $param->author_name;
        $newentry->author_modified_name = $param->author_modified_name;
        $newentry->ia_ima_id = $param->ia_ima_id;
        $newentry->file = $param->file;
        $newentry->grade = $param->grade;
        $newentry->timemodified = time();
        $newentry->timecreated = time();
        if ($param->type_assign == 1) {
            $newentry->timedue = 0;
            $newentry->timeavailable = 0;
        } //if ($param->type_assign == 1)
        else {
            $newentry->timedue = $param->timedue;
            $newentry->timeavailable = $param->timeavailable;
        }
        $newentry->preventlate = $param->preventlate;
        $newentry->test = $param->test;
        $newentry->special_param1 = $param->special_param1;
        $newentry->visible = $param->visible;
        $newentry->position = $param->position;
        $newentry->max_experiment = $param->max_experiment;
        $newentry->dependency = $param->dependency;
        $newentry->automatic_evaluate=$param->automatic_evaluate;
        $newentry->show_answer=$param->show_answer;

        if (!insert_record("ia_assign", $newentry))
            error(get_string('error_add', 'ia'));
        if ($param->type_assign==3)
           $this->update_grade_ia($param->ia_id);
 
    }

    /**
     * Update interactive activities
     */
    function update_assign($param) {

        $newentry->id = $param->assign_id;
        $newentry->name = $param->name;
        $newentry->type_assign = $param->type_assign;
        $newentry->proposition = $param->proposition;
        $newentry->ia_ima_id = $param->ia_ima_id;
        $newentry->file = $param->file;
        $newentry->grade = $param->grade;
        $newentry->author_modified_name = $param->author_modified_name;

        $newentry->timemodified = time();
        if ($param->type_assign == 1) {
            $newentry->timedue = 0;
            $newentry->timeavailable = 0;
        } //if ($param->type_assign == 1)
        else {
            $newentry->timedue = $param->timedue;
            $newentry->timeavailable = $param->timeavailable;
        }
        $newentry->preventlate = $param->preventlate;
        $newentry->test = $param->test;
        $newentry->special_param1 = $param->special_param1;
        $newentry->visible = $param->visible;
        $newentry->max_experiment = $param->max_experiment;
        $newentry->dependency = $param->dependency;
        $newentry->automatic_evaluate=$param->automatic_evaluate;
        $newentry->show_answer=$param->show_answer;

        if (!update_record("ia_assign", $newentry)) 
            error(get_string('error_update', 'ia'));
        if ($param->type_assign==3)
           $this->update_grade_ia($param->ia_id);
    }

    /**
     * Update grade of iAssign
     */
    function update_grade_ia($ia_id) {
        global $USER,$CFG, $COURSE;
        require_once($CFG->libdir . '/gradelib.php');
        $sum_grade = get_records_sql("SELECT SUM(grade) as total
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia_id'
                             AND s.type_assign=3");

        $grade_ia = get_record('ia', 'id', $ia_id);
 
        $grades = NULL;

        $params = array('itemname' => $grade_ia->name);
        $params['iteminstance'] = $ia_id;
        $params['gradetype'] = GRADE_TYPE_VALUE;
        if (key($sum_grade)){
           $params['grademax'] = key($sum_grade);
           $params['rawgrademax'] = key($sum_grade);
        
        }
        else{
            $params['grademax'] = 0;
            $params['rawgrademax'] =0;
        }
        $params['grademin'] = 0;
        grade_update('mod/ia', $grade_ia->course, 'mod', 'ia', $ia_id, 0, $grades, $params);

    }

    /**
     * Update grade of student
     */
    function update_grade_student($user_id, $ia_assign_id, $ia_id) {
        global $CFG;
        require_once($CFG->libdir . '/gradelib.php');
        $grade_ia = get_record('ia', 'id', $ia_id);
        $grade_ia_assigns = get_records('ia_assign', 'ia_id', $ia_id);
        $total_grade = 0;
        foreach ($grade_ia_assigns as $grade_ia_assign) {
            $ia_assign_submission = get_record('ia_assign_submissions', 'ia_assign_id', $grade_ia_assign->id, 'user_id', $user_id);
            $total_grade += $ia_assign_submission->grade;
        } //foreach ($grade_ia_assigns as $grade_ia_assign)
        $sum_grade = get_records_sql("SELECT SUM(grade) as total
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia_id'
                             AND s.type_assign=3");

        $grades['userid'] = $user_id;
        $grades['rawgrade'] = $total_grade;
        $params = array('itemname' => $grade_ia->name);
        $params['iteminstance'] = $ia_id;
        $params['gradetype'] = GRADE_TYPE_VALUE;

        if (key($sum_grade)){
           $params['grademax'] = key($sum_grade);
           $params['rawgrademax'] = key($sum_grade);

        }
        else{
            $params['grademax'] = 0;
            $params['rawgrademax'] =0;
        }
        grade_update('mod/ia', $grade_ia->course, 'mod', 'ia', $ia_id, 0, $grades, $params);
    }


    /**
     * Display caption of icons
     */
    function view_legend_icons() {

        global $USER, $CFG;
        $id = $this->cm->id;
        if ($this->action == 'print')
            echo '<table border=1 width=100%><tr>';
        else
            echo '<table width=100%><tr>';
        echo '<td >';
        if ($this->action != 'print')
            helpbutton('legend', get_string('legend', 'ia'), 'ia', $image = true, $linktext = false, $text = '', $return = false,
                $imagetext = '');
        echo '<strong>' . get_string('legend', 'ia') . '</strong>';
        echo '&nbsp;' . $this->icon_correct . '&nbsp;' . get_string('correct', 'ia');
        echo '&nbsp;' . $this->icon_incorrect . '&nbsp;' . get_string('incorrect', 'ia');
        echo '&nbsp;' . $this->icon_post . '&nbsp;' . get_string('post', 'ia');
        echo '&nbsp;' . $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia');
        echo '&nbsp;' . $this->icon_comment_close . '&nbsp;' . get_string('new_comment', 'ia');

        if (has_capability('mod/ia:viewreport', $this->context, $USER->id) and $this->action == 'report') {
            echo '&nbsp;' . $this->icon_comment_open . '&nbsp;' . get_string('no_new_comment', 'ia');
            echo '</td>' . "\n";
            if ($this->action != 'print') {
                $link_print = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=print&ia_id=" . $this->ia->id . "'>" . $this->icon_print . '&nbsp;' . get_string('print', 'ia') . "</a>";
                $link_stats = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=stats&ia_id=" . $this->ia->id . "'>" . $this->icon_stats . '&nbsp;' . get_string('graphic', 'ia') . "</a>";
                echo'<td width=15% align="right">' . $link_stats . '</td>' . "\n";
                echo'<td width=15% align="right">' . $link_print . '</td>' . "\n";
            } //if ($this->action != 'print')

            echo '</tr></table>' . "\n";
        }  //if (has_capability('mod/ia:viewreport', $this->context, $USER->id) and $this->action == 'report')
        elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id)) {
            $link_stats = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=stats_student&ia_id=" . $this->ia->id . "'>" . $this->icon_stats . '&nbsp;' . get_string('results', 'ia') . "</a>";
            echo'<td width=15% align="right">' . $link_stats . '</td>' . "\n";
            echo '</tr></table>' . "\n";
        } //elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id))
        else
            echo '</td></tr></table>' . "\n";
    }

    /**
     * Display activity current
     */
    function view_assign_current () {

        global $USER, $CFG, $COURSE;
        $id = $this->cm->id;
        $ia_id = $this->ia->id;
        
        //search data of current activity
        $ia_assign = get_record("ia_assign", "id", $this->assign_current);
        $this->view_header($ia_assign->name);

        //Search of iLM data used in the current activity
        $ia_ima = get_record("ia_ima", "id", $ia_assign->ia_ima_id);
        if ($this->action == 'viewsubmission'){
            if (!empty ($this->assign_submission_current) or $this->assign_submission_current!=0)
                $ia_assign_submissions = get_record("ia_assign_submissions", "id", $this->assign_submission_current); // data about activity current
            else
                $ia_assign_submissions = get_record("ia_assign_submissions", "ia_assign_id", $this->assign_current, "user_id", $this->id_user_assign); // data about student solution
        }
        else{
            $ia_assign_submissions = get_record("ia_assign_submissions", "ia_assign_id", $this->assign_current, "user_id", $this->id_user_assign); // data about student solution

        }
            
         if ($ia_assign_submissions)
               $this->update_comment($ia_assign_submissions->id);


        //file_assign: file with the script posted by the professor of exercise
        $file_assign = $CFG->dataroot . DIRECTORY_SEPARATOR . $this->course->id . DIRECTORY_SEPARATOR . $ia_assign->file;

        if (!file_exists($file_assign))
            $this->return_home_course('filenotfound');

        
        $file = $ia_assign->file;
        $this->bottonPost = 0; //hide submit button
        $this->write_solution = 0; //disable recording solution
        $this->view_assign = false; //disable visualization of activity
        $repeat = "";
        $last_assign = "";
        $answer= "";
        $comment="";
        // access teacher for test
        if (($this->action != 'viewsubmission') and (has_capability('mod/ia:evaluateassign', $this->context, $USER->id))) {
            if ($ia_assign->type_assign != 1) //activity of type example - not submit button for submission
                $this->bottonPost = 1;

            $this->view_dates($ia_assign);
            print_simple_box_start('center');
            echo '<p><strong>' . get_string('area_specific_teacher', 'ia') . '</strong></p>';
            print_simple_box_end();
            print_simple_box_start('center');
            echo '<strong>' . get_string('proposition', 'ia') . '</strong>' . "\n";
            echo '<p>' . $ia_assign->proposition . '</p>' . "\n";
            print_simple_box_end();

            if ($ia_assign->type_assign == 3) {
                print_simple_box_start('center');
                if ($ia_assign->dependency == 0) {
                    echo '<strong>' . get_string('independent_activity', 'ia') . '</strong>' . "\n";
                } else {
                    $dependencys = explode(';', $ia_assign->dependency);
                    echo '<p><strong>' . get_string('dependency', 'ia') . '</strong></p>';

                    foreach ($dependencys as $dependency) {
                        $dependencyassign = get_record("ia_assign", "id", $dependency);
                        if ($dependencyassign)
                           echo '<p>' . $dependencyassign->name . '</p>' . "\n";
                    } //foreach ($dependencys as $dependency)
                }//if ($ia_assign->dependency == 0)
                print_simple_box_end();
                print_simple_box_start('center');

                if ($ia_assign->max_experiment == 0)
                    echo '<p><strong>' . get_string('experiment', 'ia') . '</strong>&nbsp;' . get_string('ilimit', 'ia') . '</p>';
                else
                    echo '<p><strong>' . get_string('experiment_assign', 'ia') . '</strong>&nbsp;' . $ia_assign->max_experiment . '</p>' . "\n";
                echo '<p><strong>' . get_string('grade_assign', 'ia') . '</strong>&nbsp;' . $ia_assign->grade . '</p>' . "\n";

                print_simple_box_end();
            } // if ($ia_assign->type_assign == 3)

            if ($ia_assign_submissions)
              $param_aux = "action=get_answer&assign_submission_current=" . $ia_assign_submissions->id . "&id=" . $id . "&assign_current=" . $this->assign_current . "&write_solution=" . $this->write_solution . "&id_user_assign=" . $USER->id;
            else
              $param_aux = "action=get_answer&id=" . $id . "&assign_current=" . $this->assign_current . "&write_solution=" . $this->write_solution . "&id_user_assign=" . $USER->id;
            $enderecoPOST = "" . $CFG->wwwroot . "/mod/ia/view.php?" . $param_aux;
            print_simple_box_start('center');
            if ($this->confirms_jar($ia_assign->file, $ia_ima->file_jar))
               print $this->view_iMA_file($ia_assign, $answer, $enderecoPOST, true);
            print_simple_box_end();
        } //if (($this->action != 'viewsubmission') and (has_capability('mod/ia:evaluateassign', $this->context, $USER->id)))
        elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id)) { //access student
            //access student
            if ($ia_assign->type_assign == 1) {
                //// activity of type example - not submit button for submission
                $this->view_assign = true;
            } elseif ($ia_assign->type_assign == 2 and $ia_ima->evaluate == 1) {
                //// activity of type test - iLM automatic evaluator - submit button for submission
                if ($ia_assign->timeavailable < time() and $ia_assign->timedue > time()) { //activity within of deadline
                    $this->bottonPost = 1;
                    $this->view_assign = true;
                }else
                    $this->view_assign = false;
            }elseif ($ia_assign->type_assign == 3) {
                ////atividade do tipo exercicio
                $this->view_assign = true;
                if ($ia_assign->timeavailable > time())
                    $this->view_assign = false;
                elseif ($ia_assign->timedue > time() or $ia_assign->preventlate == 1) {// activity within of deadline

                    if ((!$ia_assign_submissions) or $this->action == 'repeat' or ($ia_assign_submissions and $ia_assign_submissions->experiment < 1)) {
                        $this->bottonPost = 1;
                        $this->write_solution = 1;
                    } else {
                        $last_assign = get_string('last_assign', 'ia');
                        if ($ia_assign_submissions){

                        $repeat = "<a href='view.php?action=repeat&id=" . $id . "&id_user_assign=$USER->id&assign_current=" . $this->assign_current . "&assign_submission_current=" . $ia_assign_submissions->id . "'>" . $this->icon_repeat . '&nbsp;' . get_string('repeat', 'ia') . "</a>";
                        $answer = $ia_assign_submissions->answer;
    
                        }
                        else{
                            $repeat = "<a href='view.php?action=repeat&id=" . $id . "&id_user_assign=$USER->id&assign_current=" . $this->assign_current . "'>" . $this->icon_repeat . '&nbsp;' . get_string('repeat', 'ia') . "</a>";
                          //  $answer = $ia_assign_submissions->answer;
                        }

                    }
                } elseif ($ia_assign->test == 1) { //  allowed to test after of deadline
                    if ($this->action == 'repeat' or ($ia_assign_submissions and $ia_assign_submissions->experiment < 1)) {
                        $this->bottonPost = 1;
                        $this->write_solution = 0;
                    } else {
                        $last_assign = get_string('last_assign', 'ia');
                        if ($ia_assign_submissions){
                        $repeat = "<a href='view.php?action=repeat&id=" . $id . "&id_user_assign=$USER->id&assign_current=" . $this->assign_current . "&assign_submission_current=" . $ia_assign_submissions->id . "'>" . $this->icon_repeat . '&nbsp;' . get_string('repeat', 'ia') . "</a>";
                        $answer = $ia_assign_submissions->answer;
                        }
                        else{
                         $repeat = "<a href='view.php?action=repeat&id=" . $id . "&id_user_assign=$USER->id&assign_current=" . $this->assign_current . "'>" . $this->icon_repeat . '&nbsp;' . get_string('repeat', 'ia') . "</a>";
                        }

                    }
                } //elseif ($ia_assign->test == 1)
                elseif ($ia_assign->test == 0)
                    $this->view_assign = false;

            } //elseif ($ia_assign->type_assign == 3)

            if ($ia_assign_submissions)
              $param_aux = "action=get_answer&assign_submission_current=" . $ia_assign_submissions->id . "&id=" . $id . "&assign_current=" . $this->assign_current . "&write_solution=" . $this->write_solution . "&id_user_assign=" . $USER->id;
            else
              $param_aux = "action=get_answer&id=" . $id . "&assign_current=" . $this->assign_current . "&write_solution=" . $this->write_solution . "&id_user_assign=" . $USER->id;
            $enderecoPOST = "" . $CFG->wwwroot . "/mod/ia/view.php?" . $param_aux;
            $this->view_legend_icons();
            $this->view_dates($ia_assign);

            if ($this->view_assign) {
                print_simple_box_start('center');
                echo '<table width=100% border=0 valign="top"><tr>';
                echo '<td width=60% valign="top">';
                echo '<strong>' . get_string('proposition', 'ia') . '</strong>' . "\n";
                echo '<p>' . $ia_assign->proposition . '</p>' . "\n";
                $flag_dependency = true;
                if ($ia_assign->type_assign == 3) {
                    if ($ia_assign->dependency == 0) {
                        echo '<strong>' . get_string('independent_activity', 'ia') . '</strong>' . "\n";
                    } else {
                        $dependencys = explode(';', $ia_assign->dependency);
                        echo '<p><strong>' . get_string('dependency', 'ia') . '</strong></p>';

                        foreach ($dependencys as $dependency) {
                            if ($dependency) {
                                $dependencyassign = get_record("ia_assign", "id", $dependency);
                                $dependencysubmissions = get_record("ia_assign_submissions", "ia_assign_id", $dependencyassign->id, 'user_id', $USER->id);
                                if ($dependencysubmissions) {
                                    if ($dependencysubmissions->status == 3)
                                        $icon = $this->icon_correct;
                                    elseif ($dependencysubmissions->status == 2) {
                                        $icon = $this->icon_incorrect;
                                        $flag_dependency = false;
                                    } elseif ($dependencysubmissions->status == 1) {
                                        $icon = $this->icon_post;
                                        $flag_dependency = false;
                                    } elseif ($dependencysubmissions->status == 0) {
                                        $icon = $this->icon_nopost;
                                        $flag_dependency = false;
                                    }
                                } else {
                                    $icon = $this->icon_nopost;
                                    $flag_dependency = false;
                                } //if ($dependencysubmissions)

                                echo '<p>&nbsp;' . $icon . $dependencyassign->name . '</p>' . "\n";
                            } // if ($dependency)
                        } //foreach ($dependencys as $dependency)
                    } //if ($ia_assign->dependency == 0)
                } // if ($ia_assign->type_assign == 3)
                if ($flag_dependency == false) {
                    echo '<strong>' . get_string('message_dependency', 'ia') . '</strong>' . "\n";
                    $this->view_assign = false;
                    print_simple_box_end();
                    echo '</tr></table>';
                } else {
                    $this->view_assign = true;
                    print_simple_box_end();
                    echo '</td>';
                } //if ($flag_dependency == false)

                if ($this->view_assign) {
                    if ($ia_assign->type_assign == 3) {// activity is present only if exercise
    
                        //receiver=1 - message to teacher
                        //receiver=2 - message to student
    
                        if ($ia_assign_submissions) {
                           $verify_message = get_record('ia_assign_submissions_comment', 'submission_id', $ia_assign_submissions->id, 'return_status', 0, 'receiver', 2);
                           if ($verify_message)
                             $comment = $this->icon_comment_close;
                         }
                       echo '<td width=40% valign="top" align="left">';
                        echo '<strong>' . get_string('status', 'ia') . '</strong>' . "\n";
         
                        if ($ia_assign->show_answer==1){
          
                         //check status of solution sent by the student
                        if ($ia_assign_submissions) {
                        switch ($ia_assign_submissions->status) {
                            case 3:
                                echo $this->icon_correct . '&nbsp;' . get_string('correct', 'ia') . '&nbsp;' . $comment;
                                break;
                            case 2:
                                echo $this->icon_incorrect . '&nbsp;' . get_string('incorrect', 'ia') . '&nbsp;' . $comment;
                                break;
                            case 1:
                                echo $this->icon_post . '&nbsp;' . get_string('post', 'ia') . '&nbsp;' . $comment;
                                break;
                            default:
                                echo $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia') . '&nbsp;' . $comment;
                                $repeat = "";
                                $last_assign = "";
                        } //switch ($ia_assign_submissions->status)
                        } else {
                            echo $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia') . '&nbsp;' . $comment;
                                $repeat = "";
                                $last_assign = "";
                        }

                        if ($ia_assign_submissions and $ia_assign_submissions->experiment > 0) {
                            echo '<p><strong>' . get_string('grade_student', 'ia') . ':</strong>&nbsp;' . $ia_assign_submissions->grade;
                            echo '&nbsp;&nbsp;(' . get_string('grade_assign', 'ia') . ':&nbsp;' . $ia_assign->grade . ')</p>';

                            echo '<p><strong>' . get_string('experiment_student', 'ia') . '</strong>&nbsp;' . $ia_assign_submissions->experiment;

                            if ($ia_assign->max_experiment == 0)
                                echo '&nbsp;&nbsp(' . get_string('experiment_assign', 'ia') . '&nbsp;' . get_string('ilimit', 'ia') . ')</p>';
                            else {
                                echo '&nbsp;&nbsp(' . get_string('experiment_assign', 'ia') . '&nbsp;' . $ia_assign->max_experiment . ')</p>';
                                if ($ia_assign_submissions->experiment >= $ia_assign->max_experiment) {
                                    $repeat = "";
                                    $last_assign.="&nbsp;<font color=red>" . get_string('attempts_exhausted', 'ia') . '</font>';
                                    $this->bottonPost = 0;
                                    $this->write_solution = 0;
                                } // if ($ia_assign_submissions->experiment >= $ia_assign->max_experiment)
                            } //if ($ia_assign->max_experiment == 0)

                            echo '<p><strong>' . get_string('timemodified', 'ia') . '</strong>&nbsp;' . userdate($ia_assign_submissions->timemodified) . '</p>';
                            $teacher = get_record("user", 'id', $ia_assign_submissions->teacher);
                            if ($teacher)
                                echo '<p><strong>' . get_string('last_modification', 'ia') . '</strong>&nbsp;'. $teacher->firstname . '</p>'; //"
                        } // if ($ia_assign_submissions->experiment > 0)
      
                         }//// if ($ia_assign->show_answer==1)
                         else{
 
                             if ($ia_assign_submissions->status==0){
                                echo $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia') . '&nbsp;' . $comment;
                                $repeat = "";
                                $last_assign = "";
                             }elseif ($ia_assign_submissions->status==1){
                                  echo $this->icon_post . '&nbsp;' . get_string('post', 'ia') . '&nbsp;' . $comment;

                             }
                         }
     
                              echo '</td>';
                    } //if ($ia_assign->type_assign == 3)
                    echo '</tr></table>';
                    print_simple_box_end();

                    //show iLM
                    print_simple_box_start('center');
                    echo '<table width=100% border=0 valign="top"><tr>';
                    echo '<td width=80% align="left">';
                    echo '<strong>' . $last_assign . '</strong>';
                    echo '</td>';
                    echo '<td width=20% align="rigth">';
                    echo $repeat;
                    echo '</td></tr></table>';

                    if ($this->confirms_jar($ia_assign->file, $ia_ima->file_jar)) {

                        if (!$ia_assign_submissions or $this->action == 'repeat' ){//or $ia_assign_submissions->answer==0
                                print $this->view_iMA_file($ia_assign, $answer,$enderecoPOST, true);
                       }
                       elseif ($ia_assign_submissions and $ia_assign_submissions->answer=='0'){
                            $answer="";
                            print $this->view_iMA_file($ia_assign, $answer,$enderecoPOST, true);
                        }
                        else
                            print $this->view_iMA_file($ia_assign, $answer,$enderecoPOST, false);
   
                    } //if ($this->confirms_jar($ia_assign->file, $ia_ima->file_jar))
                    print_simple_box_end();

                    if ($ia_assign->type_assign == 3) {
                        print_box_start('center');

                        if ($ia_assign_submissions){
    
                        $history_comment = $this->search_comment_submission($ia_assign_submissions->id);
                        if ($history_comment) {
                        echo "<p><b>" . get_string('history_comments', 'ia') . "</b></p>";
                        echo "<hr/>";
                        echo $history_comment;
     
                        }
                        $enderecoPOSTcomment = "" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=newcomment&assign_current=" . $this->assign_current . "&assign_submission_current=" . $ia_assign_submissions->id . "&id_user_assign=" . $this->id_user_assign;
                        }
                        else
                           $enderecoPOSTcomment = "" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=newcomment&assign_current=" . $this->assign_current . "&id_user_assign=" . $this->id_user_assign;
                        echo "<center><form name='formEnvioComment' id='formEnvioComment' method='post' action='$enderecoPOSTcomment' enctype='multipart/form-data'>";
                        echo '<p>';
                        print_textarea(0, 2, 60, null, null, "submission_comment"); //submission_comment,get_string('box_comment_message','ia'), 'onclick="clear();"'
                        echo "</p><p><input type=submit value='" . get_string('submit_comment', 'ia') . "'/></p>"; //
                        echo "</form></center>" . "\n";
     
                        print_box_end();
    
                    } //if ($ia_assign->type_assign == 3)
                } //if ($this->view_assign)
            } //if ($this->view_assign)
        }  //elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id))
        elseif (($this->action == 'viewsubmission') and (has_capability('mod/ia:evaluateassign', $this->context, $USER->id))) {//teacher evaluate
            //teacher evaluate

           $row=optional_param('row',0, PARAM_INT);
           $column=optional_param('column',0, PARAM_INT);


            $link_next= $this->icon_move_right_disable;
            $link_previous= $this->icon_move_left_disable;
            $link_up= $this->icon_move_up_disable;
            $link_down= $this->icon_move_down_disable;


            $icon_move_up = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/up.gif" alt="' . get_string('next_student', 'ia') . '" />';
            $icon_move_down = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/down.gif" alt="' . get_string('previous_student', 'ia') . '" />';
            $icon_move_left = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/left.gif" alt="' . get_string('previous_activity', 'ia') . '" />';
            $icon_move_right = '<img src="' . $CFG->wwwroot . '/mod/ia/icon/right.gif" alt="' . get_string('next_activity', 'ia') . '" />';


            if ($USER->matrix_assign[$row][$column]->assign_next!=-1){
                $url_next= "view.php?action=viewsubmission&id=$id&assign_submission_current=".$USER->matrix_assign[$row][$column+1]->assign_submission_current."&id_user_assign=$this->id_user_assign&assign_current=".$USER->matrix_assign[$row][$column]->assign_next."&view_assign=report&row=".($row)."&column=".($column+1);
                $link_next = "<a href='".$url_next."'>" . $icon_move_right."</a>";
            }

            if ($USER->matrix_assign[$row][$column]->assign_previous!=-1){
                $url_previous= "view.php?action=viewsubmission&id=$id&assign_submission_current=".$USER->matrix_assign[$row][$column-1]->assign_submission_current."&id_user_assign=$this->id_user_assign&assign_current=".$USER->matrix_assign[$row][$column]->assign_previous."&view_assign=report&row=".($row)."&column=".($column-1);
                $link_previous= "<a href='".$url_previous."'>" . $icon_move_left ."</a>";
            }

            if ($USER->matrix_assign[$row][$column]->user_next!=-1){
                $url_down= "view.php?action=viewsubmission&id=$id&assign_submission_current=".$USER->matrix_assign[$row+1][$column]->assign_submission_current."&id_user_assign=".$USER->matrix_assign[$row][$column]->user_next."&assign_current=".$this->assign_current."&view_assign=report&row=".($row+1)."&column=".($column);
                $link_down = "<a href='".$url_down."'>" . $icon_move_down."</a>";
            }

            if ($USER->matrix_assign[$row][$column]->user_previous!=-1){
                $url_up= "view.php?action=viewsubmission&id=$id&assign_submission_current=".$USER->matrix_assign[$row-1][$column]->assign_submission_current."&id_user_assign=".$USER->matrix_assign[$row][$column]->user_previous."&assign_current=".$this->assign_current."&view_assign=report&row=".($row-1)."&column=".($column);
                $link_up= "<a href='".$url_up."'>" . $icon_move_up ."</a>";
            }

            if ($ia_assign_submissions)
                $answer = $ia_assign_submissions->answer;
            $last_assign = get_string('last_assign', 'ia');

            $user_answer = get_record("user", 'id', $this->id_user_assign); //$submission_student->userid

            $this->view_dates($ia_assign);

            print_simple_box_start('center');
            echo '<table width=100% border=0 valign="top"><tr>' . "\n";
            echo '<td width=80%><font color="blue"><strong>' . get_string('area_available', 'ia') . '</strong></font>' . "\n";
            print_user_picture($user_answer, $this->course->id, $user_answer->picture, true, false, false);
            echo '&nbsp;' . $user_answer->firstname . '&nbsp;' . $user_answer->lastname;
            echo '</td>' . "\n";
            echo '<td width=20% align=right>' . "\n";
            echo '<table width=50 cellpadding="0">';
            echo '<tr><td colspan=2 align=center>'.$link_up.'</td></tr>' . "\n";
            echo '<tr><td align=center>'.$link_previous.'</td>' . "\n";
            echo '<td align=center>'.$link_next.'</td></tr>' . "\n";
            echo '<td colspan=2 align=center>'.$link_down.'</td></tr>' . "\n";
            echo '</table>' . "\n";
            echo '</td></tr></table>' . "\n";
            print_simple_box_end();

            print_simple_box_start('center');
            echo '<table width=100% border=0 valign="top"><tr>' . "\n";
            echo '<td width=60% valign="top">' . "\n";
            echo '<strong>' . get_string('proposition', 'ia') . '</strong>' . "\n";
            echo '<p>' . $ia_assign->proposition . '</p>' . "\n";
 
            if ($ia_assign->automatic_evaluate==1)
                  $resp=get_string('yes');
            else
                $resp=get_string('no');
            echo '<p>' . get_string('automatic_evaluate','ia'). '&nbsp;' . $resp. '</p>' . "\n";
            if ($ia_assign->show_answer==1)
                  $resp=get_string('yes');
            else
                $resp=get_string('no');
            echo '<p>' . get_string('show_answer','ia'). '&nbsp;' . $resp. '</p>' . "\n";
            echo '</td>';
            if ($ia_assign->type_assign == 3) {
                echo '<td width=40% valign="top" align="left">';
                echo '<strong>' . get_string('status', 'ia') . '</strong>' . "\n";

                //check status of solution sent by the student
                if ($ia_assign_submissions){
                switch ($ia_assign_submissions->status) {
                    case 3:
                        echo $this->icon_correct . '&nbsp;' . get_string('correct', 'ia') . '&nbsp;' . $comment;
                        break;
                    case 2:
                        echo $this->icon_incorrect . '&nbsp;' . get_string('incorrect', 'ia') . '&nbsp;' . $comment;
                        break;
                    case 1:
                        echo $this->icon_post . '&nbsp;' . get_string('post', 'ia') . '&nbsp;' . $comment;
                        break;
                    default:
                        echo $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia') . '&nbsp;' . $comment;
                        $last_assign = get_string('no_MA_POST_Archive', 'ia');
                } // switch ($ia_assign_submissions->status)
                }
                else
                    {
                    echo $this->icon_nopost . '&nbsp;' . get_string('not_post', 'ia') . '&nbsp;' . $comment;
                    $last_assign = get_string('no_MA_POST_Archive', 'ia');
                }

                //update_status
                if ($ia_assign_submissions and $ia_assign_submissions->experiment > 0) {
                    $edit_status = $CFG->wwwroot . "/mod/ia/view.php?action=edit_status&id=" . $id . "&id_user_assign=" . $this->id_user_assign . "&assign_current=" . $this->assign_current . "&assign_submission_current=" . $this->assign_submission_current."&row=".($row)."&column=".($column);

                    echo "
                     <script>
                     function overwriteStatus(newstatus) {
	               if (confirm('" . get_string('confirm_change_situation', 'ia') . "')){
                          document.formEditStatus.return_status.value=newstatus;
                          document.formEditStatus.submit();
                       }
                       else
                          document.formEditStatus.return_status.value=-1;
                     }
                     </script>";
                    echo "<form name='formEditStatus' method='post' action='$edit_status' enctype='multipart/form-data'>\n";
                    echo ' <font color="blue"><strong>' . get_string('changeto', 'ia') . "</strong></font>\n";
                    echo " <select name='status' onchange= 'overwriteStatus(this.value)'>\n" .
                         " <option value=\"3\">" . get_string('correct', 'ia') . "</option>\n" .
                         " <option value=\"2\">" . get_string('incorrect', 'ia') . "</option>\n" .
                         " <option value=\"1\">" . get_string('post', 'ia') . "</option>\n" .
                         " <option value=\"0\">" . get_string('not_post', 'ia') . "</option>\n" .
                         " <option value=\"-1\" selected>" . get_string('newsituation', 'ia') . "</option>\n" .
                         " </select>\n";
                    echo " <input type='hidden' name='return_status'>\n";
                    echo "</form>";

                    echo '<p><strong>' . get_string('grade_student', 'ia') . '</strong>&nbsp;' . $ia_assign_submissions->grade . '</p>';
                    echo '<p><strong>' . get_string('grade_assign', 'ia') . '</strong>&nbsp;' . $ia_assign->grade . '</p>';
                    $edit_grade = $CFG->wwwroot . "/mod/ia/view.php?action=edit_grade&id=" . $id . "&id_user_assign=" . $this->id_user_assign . "&assign_current=" . $this->assign_current . "&assign_submission_current=" . $this->assign_submission_current."&row=".($row)."&column=".($column);
                    echo "
                          <script>
                          function overwriteGrade(newgrade,maxgrade) {
                           if (newgrade<0 || newgrade>maxgrade){
                             alert('" . get_string('erro_grade', 'ia') . " '+maxgrade)
                             document.formEditGrade.return_grade.value=-1;
                             document.formEditGrade.submit();
                           }
                           else{
	                     document.formEditGrade.return_grade.value=newgrade;
                             document.formEditGrade.submit();
                           }
                         }
                        </script>";
                    echo "<form name='formEditGrade' method='post' action='$edit_grade' enctype='multipart/form-data'>\n";
                    echo ' <font color="blue"><strong>' . get_string('changeto', 'ia') . "</strong></font>" . "\n";
                    echo " <input type='text' name='grade' size='6'>";
                    echo " <input type='hidden' name='return_grade'> ";
                    echo " <input type=button value='" . get_string('confirm', 'ia') . "' onClick = 'overwriteGrade(grade.value," . $ia_assign->grade . ")' " .
                         "  title='" . get_string('confirm_new_grade', 'ia') . "'>\n";
                    echo "</form>";

                    echo '<p><strong>' . get_string('experiment', 'ia') . '</strong>&nbsp;' . $ia_assign_submissions->experiment . '</p>';
                    echo '<p><strong>' . get_string('timemodified', 'ia') . '</strong>&nbsp;' . userdate($ia_assign_submissions->timemodified) . '</p>';
                    $teacher = get_record("user", 'id', $ia_assign_submissions->teacher);
                    if ($teacher)
                        echo '<p><strong>' . get_string('last_modification', 'ia') . '</strong>&nbsp;' . $teacher->firstname . '</p>' . "\n";
                } // if ($ia_assign_submissions->experiment > 0)
                echo '</td>';
            } //if ($ia_assign->type_assign == 3)
            echo '</tr></table>';
            print_simple_box_end();

            print_simple_box_start('center');
            echo '<p><strong>' . $last_assign . '</strong></p>';
            if ($this->confirms_jar($ia_assign->file, $ia_ima->file_jar)) {
                $enderecoPOST="";
                if ($ia_assign_submissions and $ia_assign_submissions->experiment > 0)
                    print $this->view_iMA_file($ia_assign, $answer, $enderecoPOST, false);
            } //if ($this->confirms_jar($ia_assign->file, $ia_ima->file_jar))
            print_simple_box_end();
            if ($ia_assign->type_assign == 3) {
                print_box_start('center');
                echo "<p><b>" . get_string('history_comments', 'ia') . "</b></p>";
                 echo "<hr/>";
                if ($ia_assign_submissions){
                $history_comment = $this->search_comment_submission($ia_assign_submissions->id);
                if ($history_comment) 
                   echo $history_comment;
                $enderecoPOSTcomment = "" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=newcomment&assign_current=" . $this->assign_current . "&assign_submission_current=" . $ia_assign_submissions->id . "&id_user_assign=" . $this->id_user_assign."&row=".($row)."&column=".($column);
                }
                else
                   $enderecoPOSTcomment = "" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=newcomment&assign_current=" . $this->assign_current . "&id_user_assign=" . $this->id_user_assign."&row=".($row)."&column=".($column);
                echo "<center><form name='formEnvioComment' id='formEnvioComment' method='post' action='$enderecoPOSTcomment' enctype='multipart/form-data'>";
                echo '<p>';
                print_textarea(0, 2, 60, null, null, "submission_comment");//get_string('box_comment_message','ia')
                echo "</p><p><input type=submit value='" . get_string('submit_comment', 'ia') . "'\></p>"; //
                echo "</form></center>\n";
                print_box_end();
            } //if ($ia_assign->type_assign == 3)
        }
        $this->view_footer();
        die;
    }


    /**
     * Display report of performance
     */
    function report () {
        global $USER, $CFG;
        $id = $this->cm->id;
        $assign_list = get_records_list('ia_assign', 'ia_id', $this->ia->id, "position ASC");

       
        if ($this->action != 'print') {
            $title = get_string('report', 'ia');
            $this->view_header($title);
        } //if ($this->action != 'print')
        print_simple_box_start('center');

        $this->view_legend_icons();
        echo '<p>' . get_string('ps_experiment', 'ia') . '</p>';
        echo '<p>' . get_string('ps_comment', 'ia') . '</p>';
        print_simple_box_end();

        if ($this->action == 'print')
            echo '<table border=1 width="100%">' . "\n";
        else
            echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
        echo '<tr><th colspan=2 class="header c1">' . $this->ia->name . '</th></tr>' . "\n";
        $num = array();
        $i = 1;
        foreach ($assign_list as $assign) {
            $test_exercise = "";
            $ia_assign_submissions = get_records("ia_assign_submissions", "ia_assign_id", $assign->id);
            if (($ia_assign_submissions) && $assign->type_assign < 3) {
                $test_exercise = "&nbsp;<b>(" . get_string('assign_exercise', 'ia') . ")</b>";
            }// if (($ia_assign_submissions) && $assign->type_assign < 3)
            if ($assign->type_assign == 3 || ($ia_assign_submissions)) {
                $num[$i]->name = $assign->name;
                $num[$i]->id = $i;
                $num[$i]->id_assign = $assign->id;
                echo ' <tr >' . "\n";
                echo "  <td class=\"cell c1 numviews\" width=5% align='center'><strong>" . $num[$i]->id . "</strong></td>\n";
                echo "<td class=\"cell c0 actvity\">";
                echo '&nbsp;' . $num[$i]->name . '&nbsp;' . $test_exercise . "</td>";
                echo ' </tr>' . "\n";
                $i++;
            } // if ($assign->type_assign == 3 || ($ia_assign_submissions))
        } // foreach ($assign_list as $assign)
        echo "</table>";
        echo "<p></p>";
        if ($this->action == 'print')
            echo '<table border=1 width="100%">' . "\n";
        else
            echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
        $context = get_context_instance(CONTEXT_COURSE, $this->course->id);
        if ($i > 1) {
            $role = get_record_sql("SELECT s.id, s.shortname
                             FROM {$CFG->prefix}role s
                             WHERE s.shortname = 'student'");

            $students = get_records_sql("SELECT s.userid, a.firstname, a.lastname
                             FROM {$CFG->prefix}role_assignments s, {$CFG->prefix}user a
                             WHERE s.contextid = '$context->id'
                             AND s.userid = a.id
                             AND s.roleid = '$role->id'
                             ORDER BY `a`.`firstname` ASC,`a`.`lastname` ASC");

            echo '<tr><th class="header c1">' . get_string('students', 'ia') . '</th>' . "\n";
            for ($j = 1; $j < $i; $j++) {
                 $sum_assign_correct[$j]=0;
                echo '<th class="header c1" scope="col">' . $num[$j]->id . '</th>' . "\n"; // <th class="header c1" scope="col">
            }
            
            $sum_assign = $j - 1;
            echo '</tr>' . "\n";
            $total = 0;
            $sum_student = 0;
            $comment=$this->icon_comment_open;
            $sum_comment=0;
            $sum_correct_assign = array();
            $sum_correct_student = array();

           $USER->matrix_assign=array();
            if ($students){
                $w=0;
                foreach ($students as  $tmp){
                    $users_array[$w]=$tmp;
                    $w++;
                }

                for ($x = 0; $x < $w; $x++) {

                echo '<tr>' . "\n";
                $sum_student++;
                $name = $users_array[$x]->firstname . '&nbsp;' . $users_array[$x]->lastname;
                echo '  <td class=\'cell c0 actvity\'>' . $name . '</td>' . "\n";
                $total_student = 0;

                for ($j = 1; $j < $i; $j++) {
                    $sum_comment=0;

                  $student_submissions = get_record("ia_assign_submissions", 'ia_assign_id', $num[$j]->id_assign, 'user_id', $users_array[$x]->userid); // data about student solution
                echo '  <td valign="bottom" align="center" class=\'cell c1 numviews\'>' . "\n";
                if ($student_submissions) {
                    $last_solution_submission = " title=\"" . userdate($student_submissions->timemodified) . "\" "; // timemodified: time of the last student solution
                    $tentativas = $student_submissions->experiment;

                    $student_submissions_comment = get_record_sql("SELECT COUNT(submission_id)
                             FROM {$CFG->prefix}ia_assign_submissions_comment 
                             WHERE submission_id = '$student_submissions->id'");

                    if ($student_submissions_comment)
                        foreach($student_submissions_comment as $tmp)
                               $sum_comment = $tmp;

                    //informations to nagevacao between activities
                    //previous
                    if ($j-1<1 or $j==$i)
                       $assign_previous="-1";
                    else
                       $assign_previous=$num[$j-1]->id_assign;

                    if ($x-1<0 or $x==$w)
                       $user_previous="-1";
                    else
                       $user_previous=$users_array[$x-1]->userid;

                   //next
                   if ($i-1>$j)
                       $assign_next=$num[$j+1]->id_assign;
                    else
                       $assign_next="-1";

                    if ($w-1>$x)
                       $user_next=$users_array[$x+1]->userid;
                    else
                       $user_next="-1";

                    $position="&row= $x&column=$j";

                    $url = "" . $CFG->wwwroot . "/mod/ia/view.php?action=viewsubmission&id=" . $id . "&assign_submission_current=" . $student_submissions->id . "&id_user_assign=" . $users_array[$x]->userid . "&assign_current=" . $num[$j]->id_assign . "&view_assign=" . $this->view_assign;
                    $url .= $position;

                    //receiver=1 - message to teacher
                    //receiver=2 - message to student

                    $verify_message = get_record_sql("SELECT COUNT(submission_id)
                             FROM {$CFG->prefix}ia_assign_submissions_comment
                             WHERE submission_id = '$student_submissions->id'
                              AND return_status='0'
                              AND receiver='1'");

                    if ($verify_message)
                        foreach($verify_message as $tmp)
                               $sum_verify_message = $tmp;

                    if ($sum_verify_message>0)
                        $comment = $this->icon_comment_close;
                    else
                        $comment=$this->icon_comment_open;

                    if ($student_submissions->status == 3) {
                            $sum_assign_correct[$j]++;
                            $total_student++;
                            $feedback = $this->icon_correct;
                        } //if ($student_submissions->status == 3)
                        elseif ($student_submissions->status == 2) {
                            $feedback = $this->icon_incorrect;
                        } //elseif ($student_submissions->status == 2)
                        elseif ($student_submissions->status == 1) {
                            $feedback = $this->icon_post;
                        } //elseif ($student_submissions->status == 1)
                        elseif ($student_submissions->status == 0) {
                            $feedback = $this->icon_nopost;
                        } //elseif ($student_submissions->status == 0)

                        if ($this->action != 'print'){
                            echo '<table><tr>';
                            if ($tentativas>0)
                              echo '<td> <a href="' . $url . '" ' . $last_solution_submission . '>' . $feedback . '</a> &nbsp;(' . $tentativas . ')</td>'. chr(13);
                            else
                              echo '<td> <a href="' . $url . '" ' . $last_solution_submission . '>' . $feedback . '</a> </td>'. chr(13);
                            echo '<td> &nbsp; </td>';
                            echo '</tr><tr>';
                            echo '<td> &nbsp;</td>';
                            if ($sum_comment>0)
                               echo '<td>  <a href="' . $url . '"> ' . $comment  .'</a> &nbsp;(' . $sum_comment . ') </td>'. chr(13);
                            else
                               echo '<td> &nbsp;</td>';
                            echo '</tr></table>'; 
                        }

                        if ($this->action == 'print')
                            echo $feedback . '&nbsp;(' . $tentativas . ')<br>' . $comment . '&nbsp;(' . $sum_comment . ')&nbsp;' . "\n";
                    } //if ($student_submissions)
                    else {

                    //informations to nagevacao between activities
                    //previous
                    if ($j-1<1 or $j==$i)
                       $assign_previous="-1";
                    else
                       $assign_previous=$num[$j-1]->id_assign;

                    if ($x-1<0 or $x==$w)
                       $user_previous="-1";
                    else
                       $user_previous=$users_array[$x-1]->userid;

                   //next
                   if ($i-1>$j)
                       $assign_next=$num[$j+1]->id_assign;
                    else
                       $assign_next="-1";

                    if ($w-1>$x)
                       $user_next=$users_array[$x+1]->userid;
                    else
                       $user_next="-1";

                    $position="&row= $x&column=$j";
 

                        $url = "" . $CFG->wwwroot . "/mod/ia/view.php?action=viewsubmission&id=" . $id . "&id_user_assign=" . $users_array[$x]->userid . "&assign_current=" . $num[$j]->id_assign . "&view_assign=" . $this->view_assign;
                        $url .= $position;
                        $feedback = $this->icon_nopost;
                        if ($this->action == 'print')
                            echo $feedback . '&nbsp;(0)<br>' . $comment . '&nbsp;('. $sum_comment . ')&nbsp;' . "\n";
                        else{
                            echo '<table><tr>';
                            echo '<td> <a href="' . $url . '">' . $feedback . '</a> </td>'. chr(13);
                            echo '<td> &nbsp; </td>';
                            echo '</tr><tr>'. chr(13);
                            echo '<td> &nbsp;</td>';
                            if ($sum_comment>0)
                               echo '<td> <a href="' . $url . '">' . $comment  .'</a> &nbsp;(' . $sum_comment . ') </td>'. chr(13);
                            else
                               echo '<td> &nbsp;</td>';
                            echo '</tr></table>';
                        }
      
                    } //if ($student_submissions)
                    $USER->matrix_assign[$x][$j]->assign_previous=$assign_previous;
                    $USER->matrix_assign[$x][$j]->user_previous=$user_previous;
                    $USER->matrix_assign[$x][$j]->assign_next=$assign_next;
                    $USER->matrix_assign[$x][$j]->user_next=$user_next;

                    if ($student_submissions)
                      $USER->matrix_assign[$x][$j]->assign_submission_current=$student_submissions->id;
                    else
                        $USER->matrix_assign[$x][$j]->assign_submission_current=0;
                    echo '</td>' . "\n";

                } // for ($j=1; $j<$i; $j++)

                $total = $total + $total_student;
                $porcentagem = ($total_student / ($j - 1)) * 100;
                echo '</tr>' . "\n";
                $sum_correct_student[$sum_student]->name = $name;
                $sum_correct_student[$sum_student]->sum = $total_student;

            } // foreach ($students as $users_array[$x])
            //}
            for ($i = 1; $i < $j; $i++) {

                if (is_null($sum_assign_correct[$i]))
                    $sum_assign_correct[$i] = 0;
                $sum_correct_assign[$i]->sum = $sum_assign_correct[$i];
                $sum_correct_assign[$i]->name = $num[$i]->name;
            } //for ($i = 1; $i < $j; $i++)
            echo '</tr></table>' . "\n";
        }
        } // if ($i>1)
        else { 
            print_string('no_activity', 'ia');
        }// if ($i>1)
        echo "</table>";

       if ($this->action != 'print')
            $this->view_footer();
        die;
    }

    /**
     * Display graphics of performance
     */
    function stats() {

        global $USER, $CFG;
        $id = $this->cm->id;
        $assign_list = get_records_list('ia_assign', 'ia_id', $this->ia->id, "position ASC");

        if ($this->action != 'printstats') 
            $title = get_string('graphic', 'ia');
          
        $num = array();
        $i = 1;
        foreach ($assign_list as $assign) {
            $ia_assign_submissions = get_records("ia_assign_submissions", "ia_assign_id", $assign->id);
            if ($assign->type_assign == 3) { //|| ($ia_assign_submissions)
                $sum_assign_correct[$i]=0;
                $num[$i]->name = $assign->name;
                $num[$i]->id = $i;
                $num[$i]->id_assign = $assign->id;
                $i++;
            } //if ($assign->type_assign == 3)
        } // foreach ($assign_list as $assign)
        $sum_assign = $i - 1;

        $context = get_context_instance(CONTEXT_COURSE, $this->course->id);

        if ($i > 1) {
            $role = get_record_sql("SELECT s.id, s.shortname
                             FROM {$CFG->prefix}role s
                             WHERE s.shortname = 'student'");
            $students = get_records_sql("SELECT s.userid, a.firstname, a.lastname
                             FROM {$CFG->prefix}role_assignments s, {$CFG->prefix}user a
                             WHERE s.contextid = '$context->id'
                             AND s.userid = a.id
                             AND s.roleid = '$role->id'
                             ORDER BY `a`.`firstname` ASC,`a`.`lastname` ASC");

            $total = 0;
            $sum_student = 0;
            $j=0;
            $sum_correct_assign = array();
            $sum_correct_student = array();
            $sum_experiment = array();
            if ($students){
            foreach ($students as $users) {
                $sum_student++;
                $name = $users->firstname . '&nbsp;' . $users->lastname;
                // rows
                $total_student = 0;

                for ($j = 1; $j < $i; $j++) {
                    $total_experiment=0;
                    $student_submissions = get_record("ia_assign_submissions", 'ia_assign_id', $num[$j]->id_assign, 'user_id', $users->userid); // data about student solution

                    if ($student_submissions) {
                        if ($student_submissions->status == 3) {
                            $sum_assign_correct[$j]++;
                            $total_student++;
                        } // if ($student_submissions->status == 3)
                        $total_experiment+=$student_submissions->experiment;
                        }
                   $sum_experiment[$j]=$total_experiment;
                } // for ($j=1; $j<$i; $j++)


                $total = $total + $total_student;
                $sum_correct_student[$sum_student]->name = $name;
                $sum_correct_student[$sum_student]->sum = $total_student;
            } // foreach ($students as $users)
            }
            for ($i = 1; $i < $j; $i++) {
                if (is_null($sum_assign_correct[$i]))
                    $sum_assign_correct[$i] = 0;
                $sum_correct_assign[$i]->sum = $sum_assign_correct[$i];
                $sum_correct_assign[$i]->name = $num[$i]->name;
                $sum_correct_assign[$i]->experiment = $sum_experiment[$i];
            } //for ($i = 1; $i < $j; $i++) 
        } // if ($i > 1)

        if ($this->action != 'printstats') {
            $title = get_string('graphic', 'ia');
            $this->view_header($title);
            $link_report = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=report&ia_id=" . $this->ia->id . "'>" . $this->icon_report . '&nbsp;' . get_string('report', 'ia') . "</a>";
            $link_print_stats = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=printstats&&ia_id=" . $this->ia->id . "'>" . $this->icon_print . '&nbsp;' . get_string('print', 'ia') . "</a>";
            echo '<table width=100%><tr>';
            echo'<td align="right">' . $link_print_stats . '</td>' . "\n";
            echo '<td width=15% align="right">' . $link_report . '</td>';
            echo '</td></tr></table>' . "\n";

            echo "<br><br>";
            echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
            echo '<tr><th colspan=5 class="header c1">' . get_string('distribution_activity', 'ia') . '</th></tr>' . "\n";
            echo '<tr><td class=\'cell c0 actvity\' width=35%><strong>' . $this->ia->name . '</strong></td>' . "\n";
            echo '<td class=\'cell c0 actvity\' width=35%><strong>' . get_string('percentage_correct', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=10% align="right"><strong>' . get_string('proportion_correct', 'ia') . '</strong>';
            echo '<td class=\'cell c0 actvity\' width=10% align="right"><strong>' . get_string('sum_experiment', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=10% align="right"><strong>' . get_string('avg_experiment', 'ia') . '</strong></td>';
            echo '</tr>' . "\n";
            $sum_correct = 0;
            foreach ($sum_correct_assign as $assign) {
                if (is_null($assign->experiment))
                    $assign->experiment = 0;
                $bar = "";
                $sum = $assign->sum;
                $percent = ($sum / $sum_student) * 100;
                $text = number_format($percent, 1) . '%';
                $sum_correct+=$sum;
                if ($sum > 0) {
                    for ($i = 1; $i < $percent * 2; $i++)
                        $bar.= $this->hbar_blue;
                    $bar.=$this->hbar_blue_r;
                } // if ($sum > 0)
                echo '<tr ><td class=\'cell c0 actvity\'width=35%>' . $assign->name . '</td>' . "\n";
                echo '<td class=\'cell c0 actvity\' width=35%>' . $bar . '&nbsp;' . $text . '</td>';
                echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum . '/' . $sum_student . '</td>';
                echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $assign->experiment . '</td>';
                echo '<td class=\'cell c0 actvity\' width=10% align="right">' . number_format($assign->experiment / $sum_assign, 1) . '</td>';
                echo '</tr>' . "\n";
            } //foreach ($sum_correct_assign as $assign)
            echo "</table>";
            echo "<br><br>";
            echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
            echo '<tr><th colspan=3 class="header c1">' . get_string('distribution_student', 'ia') . '</th></tr>' . "\n";
            echo '<tr><td class=\'cell c0 actvity\' width=50%><strong>' . $this->ia->name . '</strong></td>' . "\n";
            echo '<td class=\'cell c0 actvity\' width=40%><strong>' . get_string('percentage_correct', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=10% align="right"><strong>' . get_string('sum_correct', 'ia') . '</strong></td>';
            echo '</tr>' . "\n";
            $sum_correct = 0;
            foreach ($sum_correct_student as $student) {
                $bar = "";
                $sum = $student->sum;
                $percent = ($sum / $sum_assign) * 100;
                $text = number_format($percent, 1) . '%';
                $sum_correct+=$sum;
                if ($sum > 0) {
                    for ($i = 1; $i < $percent * 2; $i++)
                        $bar.= $this->hbar_blue;
                    $bar.=$this->hbar_blue_r;
                } // if ($sum > 0)
                echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . $student->name . '</td>' . "\n";
                echo '<td class=\'cell c0 actvity\' width=40%>' . $bar . '&nbsp;' . $text . '</td>';
                echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum . '/' . $sum_assign . '</td>';
                echo '</tr>' . "\n";
            } //foreach ($sum_correct_student as $student)
            echo "</table>";
            echo "<br><br>";

            $var = 0;
            $cv=0;
            $dv=0;
            $avg=0;
            if ($sum_correct_student){
            $avg = $sum_correct / $sum_student;
            if ($avg>0){
            foreach ($sum_correct_student as $student) 
                $var+=pow($student->sum - $avg, 2);
          
            $var = $var / $sum_student;
            $dv = sqrt($var);
            $cv = ($dv / $avg) * 100;
            }
            }
            
            echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
            echo '<tr><th colspan=5 class="header c1">' . get_string('statistics', 'ia') . '</th></tr>' . "\n";
            echo '<tr><td class=\'cell c0 actvity\' width=20% align="center"><strong>' . get_string('sum_activity', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center"><strong>' . get_string('sum_student', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center"><strong>' . get_string('mean_score', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center"><strong>' . get_string('standard_deviation', 'ia') . '</strong></td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center"><strong>' . get_string('coefficient_variation', 'ia') . '</strong></td></tr>';
            echo '<tr><td class=\'cell c0 actvity\' width=20% align="center">' . $sum_assign . '</td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center">' . $sum_student . '</td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center">' . number_format($avg, 1) . '</td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center">' . number_format($dv, 1) . '</td>';
            echo '<td class=\'cell c0 actvity\' width=20% align="center">' . number_format($cv, 1) . '%</td></tr>';
            echo "</table>";

            $this->view_footer();
        } else {

            echo'<STYLE TYPE="text/css">
            <!--
             .boldtable
             {
             font-family:sans-serif;
             font-size:10pt;
             }
           -->
          </STYLE>'; //"

            echo '<table border=1 width=100%>' . "\n";
            echo '<tr><td colspan=3 align="center"><strong>' . get_string('distribution_activity', 'ia') . '</strong></td></tr>' . "\n";
            echo '<tr><td width=50%><strong>' . $this->ia->name . '</strong></td>' . "\n";
            echo '<td width=40%><strong>' . get_string('percentage_correct', 'ia') . '</strong></td>';
            echo '<td width=10% align="right"><strong>' . get_string('sum_correct', 'ia') . '</strong></td>';
            echo '</tr>' . "\n";
            $sum_correct = 0;
            foreach ($sum_correct_assign as $assign) {
                $bar = "";
                $sum = $assign->sum;
                $percent = ($sum / $sum_student) * 100;
                $text = number_format($percent, 1) . '%';
                $sum_correct+=$sum;
                if ($sum > 0) {
                    for ($i = 1; $i < $percent * 2; $i++)
                        $bar.= $this->hbar_blue;
                    $bar.=$this->hbar_blue_r;
                } // if ($sum > 0) 
                echo '<tr><td width=50%>' . $assign->name . '</td>' . "\n";
                echo '<td width=40%>' . $bar . '&nbsp;' . $text . '</td>';
                echo '<td width=10% align="right">' . $sum . '/' . $sum_student . '</td>';
                echo '</tr>' . "\n";
            } //foreach ($sum_correct_assign as $assign)
            echo "</table>";
            echo "<br><br>";
            echo '<table border=1 class="boldtable" width=100%>' . "\n";
            echo '<tr><td colspan=3 align="center" ><strong>' . get_string('distribution_student', 'ia') . '</strong></td></tr>' . "\n";
            echo '<tr><td width=50%><strong>' . $this->ia->name . '</strong></td>' . "\n";
            echo '<td  width=40%><strong>' . get_string('percentage_correct', 'ia') . '</strong></td>';
            echo '<td  width=10% align="right"><strong>' . get_string('sum_correct', 'ia') . '</strong></td>';
            echo '</tr>' . "\n";
            $sum_correct = 0;
            foreach ($sum_correct_student as $student) {
                $bar = "";
                $sum = $student->sum;
                $percent = ($sum / $sum_assign) * 100;
                $text = number_format($percent, 1) . '%';
                $sum_correct+=$sum;
                if ($sum > 0) {
                    for ($i = 1; $i < $percent * 2; $i++)
                         $bar.= $this->hbar_blue;
                    $bar.=$this->hbar_blue_r;
                } // if ($sum > 0)
                echo '<tr><td width=50%>' . $student->name . '</td>' . "\n";
                echo '<td width=40%>' . $bar . '&nbsp;' . $text . '</td>';
                echo '<td width=10% align="right">' . $sum . '/' . $sum_assign . '</td>';
                echo '</tr>' . "\n";
            } //foreach ($sum_correct_student as $student)
            echo "</table>";
            echo "<br><br>";

            
            $var = 0;
            $cv=0;
            $dv=0;
            $avg = 0;
            if ($sum_correct_student){
            $avg = $sum_correct / $sum_student;
            if ($avg>0){
            foreach ($sum_correct_student as $student)
                $var+=pow($student->sum - $avg, 2);

            $var = $var / $sum_student;
            $dv = sqrt($var);
            $cv = ($dv / $avg) * 100;
            }
            }



            echo '<table border=1 class="boldtable" width=100%>' . "\n";
            echo '<tr><td colspan=5 align="center"><strong>' . get_string('statistics', 'ia') . '</strong></th></tr>' . "\n";
            echo '<tr><td width=20% align="center"><strong>' . get_string('sum_activity', 'ia') . '</strong></td>';
            echo '<td  width=20% align="center"><strong>' . get_string('sum_student', 'ia') . '</strong></td>';
            echo '<td  width=20% align="center"><strong>' . get_string('mean_score', 'ia') . '</strong></td>';
            echo '<td  width=20% align="center"><strong>' . get_string('standard_deviation', 'ia') . '</strong></td>';
            echo '<td  width=20% align="center"><strong>' . get_string('coefficient_variation', 'ia') . '</strong></td></tr>';
            echo '<tr><td  width=20% align="center">' . $sum_assign . '</td>';
            echo '<td  width=20% align="center">' . $sum_student . '</td>';
            echo '<td  width=20% align="center">' . number_format($avg, 1) . '</td>';
            echo '<td  width=20% align="center">' . number_format($dv, 1) . '</td>';
            echo '<td  width=20% align="center">' . number_format($cv, 1) . '%</td></tr>';
            echo "</table>";
        } //if ($this->action != 'printstats')
        die;
    }


    /**
     * Display graphics of performance for students
     */
    function stats_students () {
        global $USER, $CFG;
        $id = $this->cm->id;
        $ia_assign = get_records_sql("SELECT *
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '{$this->ia->id}'
                             AND s.type_assign=3
                             ORDER BY `s`.`position`");

        $title = get_string('results', 'ia');
       // $this->view_header($title);

        $sum_correct = 0;
        $sum_incorrect = 0;
        $sum_post = 0;
        $sum_nopost = 0;
        $sum_assign = count($ia_assign);
        $bar_nopost="";
        $bar_correct="";
        $bar_incorrect="";
        $bar_post="";
        
        foreach ($ia_assign as $assign) {
            $ia_assign_submissions = get_record("ia_assign_submissions", 'ia_assign_id', $assign->id, 'user_id', $USER->id); // data about student solution
           if ($ia_assign_submissions){
            if ($ia_assign_submissions->status == 3)
                $sum_correct++;
            elseif ($ia_assign_submissions->status == 2)
                $sum_incorrect++;
            elseif ($ia_assign_submissions->status == 1)
                $sum_post++;
            elseif ($ia_assign_submissions->status == 0 or (!$ia_assign_submissions))
                $sum_nopost++;
           }//if ($ia_assign_submissions)
        } //foreach ($ia_assign as $assign)

        $percent_correct = ($sum_correct / $sum_assign) * 100;
        $text_correct = number_format($percent_correct, 1) . '%';
        if ($sum_correct > 0) {
            for ($i = 1; $i < $percent_correct * 2; $i++)
                $bar_correct.= $this->hbar_green;
            $bar_correct.=$this->hbar_green_r;
        } // if ($sum_correct > 0)

        $percent_incorrect = ($sum_incorrect / $sum_assign) * 100;
        $text_incorrect = number_format($percent_incorrect, 1) . '%';
        if ($sum_incorrect > 0) {
            for ($i = 1; $i < $percent_incorrect * 2; $i++)
                $bar_incorrect.= $this->hbar_red;
            $bar_incorrect.=$this->hbar_red_r;
        } // if ($sum_incorrect > 0)

        $percent_post = ($sum_post / $sum_assign) * 100;
        $text_post = number_format($percent_post, 1) . '%';
        if ($sum_post > 0) {
            for ($i = 1; $i < $percent_post * 2; $i++)
                $bar_post.= $this->hbar_blue;
            $bar_post.=$this->hbar_blue_r;
        } //if ($sum_post > 0)

        $percent_nopost = ($sum_nopost / $sum_assign) * 100;
        $text_nopost = number_format($percent_nopost, 1) . '%';
        if ($sum_nopost > 0) {
            for ($i = 1; $i < $percent_nopost * 2; $i++)
                $bar_nopost.= $this->hbar_orange;
            $bar_nopost.=$this->hbar_orange_r;
        } //if ($sum_nopost > 0)

        $this->view_header($title);
        $link_return = "&nbsp;<a href='" . $this->return . "'>" . $this->icon_home . get_string('activities_page', 'ia') . "</a>";
        echo '<table width=100%><tr>';
        echo'<td align="right">' . $link_return . '</td>' . "\n";
        echo '</td></tr></table>' . "\n";

        echo "<br><br>";
        echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";

        echo '<tr><th colspan=3 class="header c1">';
        helpbutton('legend', get_string('legend', 'ia'), 'ia', $image = true, $linktext = false, $text = '', $return = false,
                $imagetext = '');
        echo $this->ia->name . '</th></tr>' . "\n";

        echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . get_string('correct', 'ia') . '</td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=40%>' . $bar_correct . '&nbsp;' . $text_correct . '</td>';
        echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum_correct . '/' . $sum_assign . '</td>';
        echo '</tr>' . "\n";
        echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . get_string('incorrect', 'ia') . '</td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=40%>' . $bar_incorrect . '&nbsp;' . $text_incorrect . '</td>';
        echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum_incorrect . '/' . $sum_assign . '</td>';
        echo '</tr>' . "\n";
        if ($sum_post) {
            echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . get_string('post', 'ia') . '</td>' . "\n";
            echo '<td class=\'cell c0 actvity\' width=40%>' . $bar_post . '&nbsp;' . $text_post . '</td>';
            echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum_post . '/' . $sum_assign . '</td>';
            echo '</tr>' . "\n";
        } // if ($sum_post) 
        echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . get_string('not_post', 'ia') . '</td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=40%>' . $bar_nopost . '&nbsp;' . $text_nopost . '</td>';
        echo '<td class=\'cell c0 actvity\' width=10% align="right">' . $sum_nopost . '/' . $sum_assign . '</td>';
        echo '</tr>' . "\n";
        echo "</table>";
        echo "<br><br>";
        echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . "\n";
        echo '<tr><th colspan=3 class="header c1">' . get_string('grades', 'ia') . '</th></tr>' . "\n";
        echo '<tr><td class=\'cell c0 actvity\' width=50%><strong>' . $this->ia->name . '</strong></td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=25% align=right><strong>' . get_string('grade_student', 'ia') . '</strong></td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=25% align=right><strong>' . get_string('grade_assign', 'ia') . '</strong></tr>' . "\n";

        $sum_grade = 0;
        $sum_grade_student = 0;
        foreach ($ia_assign as $assign) {
            $ia_assign_submissions = get_record("ia_assign_submissions", 'ia_assign_id', $assign->id, 'user_id', $USER->id);
            if (!$ia_assign_submissions)
                $ia_assign_submissions->grade = 0;
            echo '<tr ><td class=\'cell c0 actvity\'width=50%>' . $assign->name . '</td>' . "\n";
            echo '<td class=\'cell c0 actvity\' width=25% align=right>' . $ia_assign_submissions->grade . '</td>';
            echo '<td class=\'cell c0 actvity\' width=25% align=right>' . $assign->grade . '</td>';
            echo '</tr>' . "\n";

            $sum_grade +=$assign->grade;
            $sum_grade_student+=$ia_assign_submissions->grade;
        } //foreach ($ia_assign as $assign)
        $avg = $sum_grade_student / $sum_grade * 100;

        echo '<tr><td class=\'cell c0 actvity\' width=50%><strong>' . get_string('total', 'ia') . '</strong></td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=25% align=right><strong>' . $sum_grade_student . '</strong></td>' . "\n";
        echo '<td class=\'cell c0 actvity\' width=25% align=right><strong>' . $sum_grade . '</strong></tr>' . "\n";
        echo '<tr><td class=\'cell c0 actvity\' width=25% align=left><strong>' . get_string('percentage_correct', 'ia') . '</strong></td>' . "\n";
        echo '<td colspan=2 class=\'cell c0 actvity\' align=right><strong>' . number_format($avg, 1) . '%</strong></tr>' . "\n";
        echo "</table>";

        $this->view_footer();
        die;
    }


    /**
     * Display page of iAssigns
     */
    function view_assigns () {
        global $USER, $CFG, $COURSE;
        $id = $this->cm->id;
        $assign_list = get_records_list('ia_assign', 'ia_id', $this->ia->id, "position ASC");

        print_simple_box_start('center');
        echo '<table width=100% border=0><tr>';

        $link_add = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=add&ia_id=" . $this->ia->id . "'>" . $this->icon_add_assign . get_string('add_assign', 'ia') . "</a>";

        $link_report = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=report&ia_id=" . $this->ia->id . "'>" . $this->icon_report . get_string('report', 'ia') . "</a>";

        if (has_capability('mod/ia:viewassignall', $this->context, $USER->id)) {
            echo '<td width=10% align="left">';
            echo $link_report;
            echo '</td>';
        } //if (has_capability('mod/ia:viewassignall', $this->context, $USER->id))
        if (has_capability('mod/ia:editassign', $this->context, $USER->id)) {
            echo '<td width=15% align="left">';
            echo $link_add;
            echo "</td>\n";
        } //if (has_capability('mod/ia:editassign', $this->context, $USER->id))
        if (has_capability('mod/ia:editassign', $this->context, $USER->id)) {
            if ($assign_list) {
                echo '<td align="right">' . "\n";

                // $USER->assignEdit == 0 view 'Turn editing off'
                // $USER->assignEdit == 1 view 'Turn editing on'
                if (!isset($USER->assignEdit))
                   $USER->assignEdit = 0;

                if ($USER->assignEdit == 0) {
                    $bottonEdit_message = get_string('turneditingon', 'ia');
                    $botton = 1;
                }  // if ($USER->assignEdit == 0)
                elseif ($USER->assignEdit == 1) {
                    $bottonEdit_message = get_string('turneditingoff', 'ia');
                    $botton = 0;
                } //elseif ($USER->assignEdit == 1)
                $editPost = "" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&botton=" . $botton;
                echo "\n<form name='formEditPost' id='formEditPost' method='post' action='$editPost' enctype='multipart/form-data'>";
                echo " <input type=submit value='$bottonEdit_message'/>\n";
                echo "</form>\n";
                echo "</td>\n";
            } //if ($assign_list)
        }
        echo '</tr></table>';

        if (has_capability('mod/ia:submitassign', $this->context, $USER->id))
            $this->view_legend_icons();

        print_simple_box_end();
        $assign_array_exercise = array();
        $i_exercise = 0;
        $assign_array_test = array();
        $i_test = 0;
        $assign_array_example = array();
        $i_example = 0;
        $assign_array_general = array();
        $i_general = 0;

        if ($this->ia->activity_group == 0) {
            if ($assign_list){
            foreach ($assign_list as $assign) {
                $assign_array_general[$i_general] = $assign;
                $i_general++;
            } //foreach ($assign_list as $assign)
            }
        }  //if ($this->ia->activity_group == 0)
        else {
            if ($assign_list){
            foreach ($assign_list as $assign) {
                if ($assign->type_assign == 3) {
                    $assign_array_exercise[$i_exercise] = $assign;
                    $i_exercise++;
                } //if ($assign->type_assign == 3)
                if ($assign->type_assign == 2) {
                    $assign_array_test[$i_test] = $assign;
                    $i_test++;
                } //if ($assign->type_assign == 2)
                if ($assign->type_assign == 1) {
                    $assign_array_example[$i_example] = $assign;
                    $i_example++;
                }//if ($assign->type_assign == 1) 
            }//foreach ($assign_list as $assign)
        }
        }
        if ($assign_array_exercise) {
            $title = get_string('exercise', 'ia');
            $this->show_assign($title, $assign_array_exercise, $i_exercise);
        } // if ($assign_array_exercise)
        if ($assign_array_test) {
            $title = get_string('test', 'ia');
            $this->show_assign($title, $assign_array_test, $i_test);
        } // if ($assign_array_test)
        if ($assign_array_example) {
            $title = get_string('example', 'ia');
            $this->show_assign($title, $assign_array_example, $i_example);
        } // if ($assign_array_example)
        if ($assign_array_general) {
            $title = "";
            $this->show_assign($title, $assign_array_general, $i_general);
        } //if ($assign_array_general)
        if (count($assign_list) > 5 and !(has_capability('mod/ia:submitassign', $this->context, $USER->id))) {
            print_simple_box_start('center');
            echo '<table width=100% border=0><tr>';

            if (has_capability('mod/ia:viewassignall', $this->context, $USER->id)) {
                echo '<td width=10% align="left">';
                echo $link_report;
                echo '</td>';
            } // if (has_capability('mod/ia:viewassignall', $this->context, $USER->id))
            if (has_capability('mod/ia:editassign', $this->context, $USER->id)) {
                echo '<td align="left">';
                echo $link_add;
                echo '</td>';
            } //if (has_capability('mod/ia:editassign', $this->context, $USER->id))
            echo '</tr></table>';
            print_simple_box_end();
        } // if (count($assign_list) > 5 and !(has_capability('mod/ia:submitassign', $this->context, $USER->id)))
    }

    /**
     * Display all iAssigns
     */
    function show_assign ($title, $assign_array, $i) {
        global $USER, $CFG;

        $id = $this->cm->id;
        print_simple_box_start("center");
        if (has_capability('mod/ia:viewassignall', $this->context, $USER->id)) {
            echo "<p><font color='#0000aa'><strong>" . $title . "</strong></font></p>";
            for ($j = 0; $j < $i; $j++) {

                $assign_current = $assign_array[$j]->id;

                 if ($j==$i-1)
                   $assign_down = $assign_array[$j]->id;
                 else
                   $assign_down = $assign_array[$j + 1]->id;

                if ($j>0)
                   $assign_up = $assign_array[$j - 1]->id;
                else
                   $assign_up = $assign_array[$j]->id;

                if ($assign_array[$j]->visible == 0)
                    $links = "&nbsp;<a href='view.php?id=$id&id_user_assign=$USER->id&action=view&assign_current=$assign_current'><font color='#bbbbbb'>" . $assign_array[$j]->name . "</font></a>";
                else
                    $links="&nbsp;<a href='view.php?id=$id&id_user_assign=$USER->id&action=view&assign_current=$assign_current'>" . $assign_array[$j]->name . "</a> <font size='1'>(arquivo: ".$assign_array[$j]->file.")</font>";

            
                if (has_capability('mod/ia:editassign', $this->context, $USER->id) and $USER->assignEdit == 1 ) {

                    $aux = "&id=$id&assign_current=$assign_current&assign_up=$assign_up&assign_down=$assign_down";
                    $link_up = "&nbsp;<a href='view.php?action=up$aux'>" . $this->icon_move_up . "</a>";
                    $link_down = "&nbsp;<a href='view.php?action=down$aux'>" . $this->icon_move_down . "</a>";
                    $link_delete = "&nbsp;<a href='view.php?action=delete$aux'>" . $this->icon_delete . "</a>";
                    $link_visible_hide = "&nbsp;<a href='view.php?action=visible$aux'>" . $this->icon_hide . "</a>";
                    $link_visible_show = "&nbsp;<a href='view.php?action=visible$aux'>" . $this->icon_show . "</a>";
                    $link_edit = "&nbsp;<a href='view.php?action=edit$aux'>" . $this->icon_edit . "</a>";
    
                    if (count($assign_array) > 1) {
                        if ($j == 0)
                            $links .=$link_down;
                        elseif ($j == $i - 1)
                            $links .=$link_up;
                        else
                            $links .=$link_up . $link_down;
                    } //if (count($assign_array) > 1)
                    $links .=$link_edit . $link_delete;

                    if ($assign_array[$j]->visible == 0)
                        $links .= $link_visible_show;
                    else
                        $links .= $link_visible_hide;
                } //if ($USER->assignEdit == 1 && has_capability('mod/ia:editassign', $this->context, $USER->id))
                echo '<p>' . $links . '</p>' . "\n";
            }
        } //if (has_capability('mod/ia:viewassignall', $this->context, $USER->id))
        elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id)) { //student
            echo '<table width=100% ><tr>';
            echo "<td width=70% align='left'><font color='#0000aa'><strong>" . $title . "</strong></font></td>" . "\n";
            echo '</tr></table>' . "\n";

            for ($j = 0; $j < $i; $j++) {
                $icon_status = "";
                $icon_comment = "";
                if ($assign_array[$j]->visible == 1) {
                    $assign_current = $assign_array[$j]->id;
                    $ia_assign_submissions = get_record('ia_assign_submissions', 'ia_assign_id', $assign_current, 'user_id', $USER->id);

                    $links = "&nbsp;<a href='view.php?id=$id&id_user_assign=$USER->id&action=view&assign_current=$assign_current'>" . $assign_array[$j]->name . "</a>";
                    $icon_status = "";
                    $icon_comment="";
                    if ($ia_assign_submissions) {

                        //receiver=1 - message to teacher
                        //receiver=2 - message to student
        
                        $verify_message = get_record_sql("SELECT COUNT(submission_id)
                             FROM {$CFG->prefix}ia_assign_submissions_comment 
                             WHERE submission_id = '$ia_assign_submissions->id'
                             and  return_status= 0 and receiver=2");

                       if ($verify_message)
                        foreach($verify_message as $tmp)
                               $sum_comment = $tmp;
            
                        if ($sum_comment>0)
                            $icon_comment = $this->icon_comment_close;

                        if ($assign_array[$j]->type_assign == 3) {
                            if ($assign_array[$j]->show_answer==1){
                            if ($ia_assign_submissions->status == 3)
                                $icon_status = $this->icon_correct;
                            elseif ($ia_assign_submissions->status == 2)
                                $icon_status = $this->icon_incorrect;
                            elseif ($ia_assign_submissions->status == 1)
                                $icon_status = $this->icon_post;
                            elseif ($ia_assign_submissions->status == 0)
                                $icon_status = $this->icon_nopost;
                            }//if ($assign_array[$j]->show_answer==1)
                            else
                            {
                                if ($ia_assign_submissions->status == 0)
                                    $icon_status = $this->icon_nopost;
                                else
                                    $icon_status = $this->icon_post;
                            }
                        } //if ($assign_array[$j]->type_assign == 3)
                    } //if ($ia_assign_submissions)
                    elseif ($assign_array[$j]->type_assign == 3) {
                        $icon_status = $this->icon_nopost;
                    } //if ($assign_array[$j]->type_assign == 3)
                    echo '<p>' . $icon_status . '&nbsp;' . $links . '&nbsp;' . $icon_comment . '</p>' . "\n";
                } //if ($assign_array[$j]->visible == 1)
            } //for ($j = 0; $j < $i; $j++)
        } //elseif (has_capability('mod/ia:submitassign', $this->context, $USER->id))
        else {
            print_string('no_permission_assign', 'ia');
        }
        print_simple_box_end();
    }


    /**
     * Show message of return
     */

    function return_home_course($message) {
        $link_return = "&nbsp;<a href='" . $this->return . "'>" . $this->icon_home . get_string('activities_page', 'ia') . "</a>";
        print_simple_box_start('center');
        echo '<table width=100% border=0 valign="top">';
        echo '<tr><td align="left"><strong>';
        print_string($message, 'ia');
        echo '</strong></td>';
        echo '<td width=20% align="right">';
        echo $link_return;
        echo '</td></tr></table>';
        print_simple_box_end();
        $this->view_footer();
        die;
    }

    /**
     * Show footer of page
     */
    function view_footer () {
        print_footer($this->course);
    }

    /**
     * Shows date of opening and closing activities
     */
    function view_dates($ia_assign) {

        global $USER, $CFG;
        $id = $this->cm->id;
        $link_return = "&nbsp;<a href='" . $this->return . "'>" . $this->icon_home . get_string('activities_page', 'ia') . "</a>";
        $status_assign="";
        $status_assign1="";
        $status_assign2="";
        if ($ia_assign->type_assign == 1)// activity of type example
            $type_assign = get_string('example_assign', 'ia');
        elseif ($ia_assign->type_assign == 2) {// activity of type test
            $type_assign = get_string('test_assign', 'ia');
            if ($ia_assign->timeavailable > time()) {
                $status_assign = get_string('previous_timeavailable', 'ia');
            } elseif ($ia_assign->timedue < time()) {
                $status_assign = get_string('last_timedue', 'ia');
            }
        } elseif ($ia_assign->type_assign == 3) {//activity of type exercise
            $type_assign = get_string('exercise_assign', 'ia');
            if ($ia_assign->timeavailable > time())
                $status_assign = get_string('previous_timeavailable', 'ia'); // before of deadline
            elseif ($ia_assign->timedue < time()) {// after delivery
                $status_assign = get_string('last_timedue', 'ia');
                if ($ia_assign->preventlate == 1)// permitted to submit after the deadline
                    $status_assign1 = get_string('duedate_preventlate_enable', 'ia');
                elseif ($ia_assign->preventlate == 0) {// not permitted to submit after the deadline
                    $status_assign1 = get_string('duedate_preventlate_desable', 'ia');
                    if ($ia_assign->test == 1) // allowed to test after of deadline
                        $status_assign2 = get_string('test_preventlate', 'ia');
                    elseif ($ia_assign->test == 0) { // not allowed to test after of deadline
                        $status_assign2 = get_string('test_preventlate_no', 'ia');
                    } //elseif ($ia_assign->test == 0)
                } //elseif ($ia_assign->preventlate == 0)
            } //elseif ($ia_assign->timedue < time())
        } //elseif ($ia_assign->type_assign == 3)

        print_simple_box_start('center');
        echo '<table  width=100% ><tr>';
        echo '<td width=80%>' . $type_assign . '</td>';

        if (has_capability('mod/ia:viewassignall', $this->context, $USER->id) and ($ia_assign->type_assign == 3)) {
            $link_report = "<a href='" . $CFG->wwwroot . "/mod/ia/view.php?id=" . $id . "&action=report&ia_id=" . $this->ia->id . "'>" . $this->icon_report . '&nbsp;' . get_string('report', 'ia') . "</a>";
            echo '<td width=20% align="right">' . $link_report . '</td>';
        } else {
            echo '<td width=20% align="right">' . $link_return . '</td>';
        } //if (has_capability('mod/ia:viewassignall', $this->context, $USER->id) and ($ia_assign->type_assign == 3))
        echo '</tr></table>';
        echo '<table  width=100% >';
        if ($ia_assign->type_assign > 1) {
            if ($ia_assign->timeavailable)
                echo '<tr><td width=50% align="left"> <strong>' . get_string('availabledate', 'ia') . ':</strong>&nbsp;' . userdate($ia_assign->timeavailable) . '</td>';
            if ($ia_assign->timedue)
                echo '<td width=50% align="left"><strong>' . get_string('duedate', 'ia') . ':</strong>&nbsp;' . userdate($ia_assign->timedue) . '</td>';
        } //if ($ia_assign->type_assign > 1)
        echo '<tr><td><font color="red">' . $status_assign . '&nbsp;' . $status_assign1 . '<br>' . $status_assign2 . '</font></td></tr>';
        echo '</table>';
        print_simple_box_end();
    }

    /**
     * Confirms the existence of the jar file
     */
    function confirms_jar ($file, $file_jar) {
        global $USER, $CFG;
        $filename = $CFG->dirroot . "/mod/ia/ma/" . $file_jar;

        $extension = explode(".", $file);
        $ia_ima = get_record('ia_ima', 'file_jar', $file_jar);

        if ($ia_ima->extension != $extension[1]) {
            echo get_string('error_confirms_gab', 'ia');
            return false; 
        } elseif (count($ia_ima) < 1) {
            echo get_string('error_confirms_ima', 'ia');
            return false; 
        } elseif (!file_exists($filename)) {
            echo get_string('error_confirms_jar', 'ia');
            return false; 
        } 
        else{
            return true;
        }//if ($ia_ima->extension != $extension[1])
    }

    /**
     * Writes data to secure access to interactive activities
     */
    function write_iMA_security ($ia_assign_id, $file) {
        global $CFG, $USER, $COURSE;
        $newentry->ia_assign_id = $ia_assign_id;
        $newentry->user_id = $USER->id;
        $newentry->file = $file;
        $newentry->timecreated = time();
        $newentry->view=1;
        $id_iMA_security=insert_record("ia_assign_security", $newentry);
        if (!$id_iMA_security) {
            error(get_string('error_security', 'ia'));
        } //if (!insert_record("ia_assign_security", $newentry))

        return $id_iMA_security;
    }

    /**
     * Shows activity in iLM
     * */
    function view_iMA_file ($ia_assign, $student_answer,$enderecoPOST, $view) {
        global $USER, $CFG, $COURSE;

        $notSEND = 'true'; // $notSEND='false';
        //Search of iLM data used in the current activity
        $ia_ima = get_record("ia_ima", "id", $ia_assign->ia_ima_id);

        $file_jar = $ia_ima->file_jar;
        $arquivo_class = $ia_ima->file_class;
        $largura = $ia_ima->width;
        $altura = $ia_ima->heigth;

        $special_param1=$ia_assign->special_param1;
        delete_records("ia_assign_security", "ia_assign_id", $ia_assign->id, "user_id", $USER->id);

        /*
         * $view==true  - file with exercise
         * $view==false - exercise submitted by the student (search database)
         */
        if ($ia_ima->name=="iGeom"){ // is iGeom exercise of script
           $file = $CFG->dataroot . DIRECTORY_SEPARATOR . $COURSE->id . DIRECTORY_SEPARATOR . $ia_assign->file;
           if ($special_param1==1 and !empty ($student_answer) and (!$view)) 
              $view=1;
           elseif (!$view)
              $file = $student_answer;
           
        } else {
            if ($view)
                $file = $CFG->dataroot . DIRECTORY_SEPARATOR . $COURSE->id . DIRECTORY_SEPARATOR . $ia_assign->file;
            else
               $file = $student_answer;
        }

       $id_iMA_security = $this->write_iMA_security($ia_assign->id, addslashes($file));
       $ia_iMA_security = get_record("ia_assign_security", "id", $id_iMA_security);
       $token = md5($ia_iMA_security->timecreated);
       $end_file = $CFG->wwwroot . DIRECTORY_SEPARATOR . 'mod' . DIRECTORY_SEPARATOR . 'ia' . DIRECTORY_SEPARATOR . 'ima_security.php?id=' . $id_iMA_security . '&token=' . $token . '&view=' . $view;

       $ia = "
        <script>
         function resp() {
	   var strAnswer = document.applets[0].getAnswer();
           var value = document.applets[0].getEvaluation();
             if (strAnswer==null || strAnswer=='') { // undefined
               // alert('O iMA não tem qualquer conteúdo a enviar...'+value+': '+strAnswer);
               alert('".get_string('activity_empty', 'ia')."');
               return false; // sem erro
             }
             else
             if (strAnswer==-1) { // file wasn't modified: student makes nothing!
                alert('".get_string('submit_empty', 'ia')."');
                return false; // sem erro
             }

	   else {
              document.formEnvio.MA_POST_Archive.value = strAnswer;
              document.formEnvio.MA_POST_Value.value = value;
	      document.formEnvio.submit();
              return true; // com erro
              }
           }
       </script>"; //"

        $lang = substr(current_language(), 0, 2);
        $ia .= "<center><form name='formEnvio' id='formEnvio' method='post' action='$enderecoPOST' enctype='multipart/form-data'>
        <applet name='eMA' codebase='./ma/' code='$arquivo_class' archive='$file_jar' width='$largura' height='$altura' vspace=10 hspace=10>
        <param name='MA_PARAM_PropositionURL' value='true'/>
        <param name='MA_PARAM_notSEND' value='$notSEND'/>
         <param name='lang' value='$lang'/>
         <param name='MA_PARAM_addresPOST' value='$enderecoPOST'> <!-- 2 -->
         <param name='MA_PARAM_Proposition' value='".$end_file."'>" . $this->special_param($special_param1,$student_answer) . "
         </applet> <br/>
        <input type='hidden' name='MA_POST_Archive'>
        <input type='hidden' name='MA_POST_Value'>";

        if ($this->bottonPost == 1)
            $ia .= "<center>
            <input type=button value='" . get_string('submit_assign', 'ia') . "' onClick = 'resp()'
                 title='" . get_string('message_submit_assign', 'ia') . "'>
            </center>";
        $ia .= "</form></center>";
        return $ia;
    }

   
    /**
     * inserts the parameter that displays special algorithm for sending through of iLM
     * feature specific to iLM iGeom
     */
    function special_param ($special_param1, $student_answer) {
        if ($special_param1 == 1) {
	   // is iGeom exercise of script
           $param = "\n         <param name='TIPO_SCRIPT' value='1'>\n".
                      "         <param name='BOTAOSCR1' value='".$student_answer."' />";
           }
        else
            $param="";
        return $param;
    }

    /**
     * Search comment of activity
     */

    function search_comment_submission ($id_submission) {
        global $USER;
        $comments = get_records_list('ia_assign_submissions_comment', 'submission_id', $id_submission, 'timecreated DESC'); //'ORDER BY "timecreated" ASC'
        $text = "";
        if ($comments){
        foreach ($comments as $tmp) {
            $user_answer = get_record("user", 'id', $tmp->comment_author_id);
            $text .='<b>' . $user_answer->firstname . '</b>';
            $text .='&nbsp;(' . userdate($tmp->timecreated) . ')<br>';
            $text .=$tmp->comment;
            $text .='<hr/>';
        } //foreach ($comments as $tmp)
        }
        return $text;
    }

    /**
     * Update comment of activity
     */
    function update_comment ($submission_id) {
        global $USER;
        if (!has_capability('mod/ia:submitassign', $this->context, $USER->id))
            $receiver = 1; // student message to teacher
        else
            $receiver= 2;  // teacher message to student

        $verify_message = get_records('ia_assign_submissions_comment', 'submission_id', $submission_id); //

  
        if ($verify_message){
        foreach ($verify_message as $message) {
            if ($message->receiver == $receiver) {
                $newentry->id = $message->id;
                $newentry->return_status = 1;
                if (!update_record('ia_assign_submissions_comment', $newentry)) {
                    error(get_string('error_update', 'ia'));
                } // if (!update_record('ia_assign_submissions_comment', $newentry))
            } //if ($message->receiver == $receiver)
            add_to_log($this->course->id, "ia", "update comment", "view.php?id={$this->ia->id}", $submission_id, $this->cm->id, $USER->id);
        } //foreach ($verify_message as $message)
    }
    }

    /**
     * Record comment of activity
     */
    function write_comment_submission() {
        global $USER, $CFG;
        $id = $this->cm->id;
        $submission_comment = optional_param('submission_comment',NULL);
        $sum_comment=0;

        $return = "" . $CFG->wwwroot . "/mod/ia/view.php?action=view&id=" . $id . "&assign_submission_current=" . $this->assign_submission_current . "&id_user_assign=" . $this->id_user_assign . "&assign_current=" . $this->assign_current;

        $link_return = "&nbsp;<a href='" . $return . "'>" . $this->icon_return . get_string('return', 'ia') . "</a>";

        $str1 = trim($submission_comment);
        $str2 = trim(get_string('box_comment_message', 'ia'));

        if (!empty($submission_comment) and (strcmp($str1, $str2) != 0 )){
           if (has_capability('mod/ia:submitassign', $this->context, $USER->id)) {
             $receiver = 1; // student message to teacher
             $this->action = 'view';
           } else {
             $receiver = 2;  // teacher message to student
             $this->action = 'viewsubmission';
           } //if (has_capability('mod/ia:submitassign', $this->context, $USER->id))

          $ia_assign_submissions = get_record("ia_assign_submissions", "id", $this->assign_submission_current);

            if (!$ia_assign_submissions) {
                $ia_assign = get_record("ia_assign", "id", $this->assign_current);
                $id_submission = $this->new_submission($ia_assign->id, $this->id_user_assign, $receiver);
                $this->assign_submission_current = $id_submission;
            } else {
                $id_submission = $ia_assign_submissions->id;
            }// if (!$ia_assign_submissions)

            $comments = get_record_sql("SELECT COUNT(submission_id)
                             FROM {$CFG->prefix}ia_assign_submissions_comment
                             WHERE submission_id = '$id_submission'
                             and comment='$submission_comment'
                             and comment_author_id='$USER->id'"); //

            if ($comments)
               foreach($comments as $tmp)
                       $sum_comment = $tmp;

            if ($sum_comment==0) {
                $newentry->submission_id = $id_submission;
                $newentry->comment_author_id = $USER->id;
                $newentry->timecreated = time();
                $newentry->comment = $submission_comment;
                $newentry->receiver = $receiver;
                $ia_assign_submissions_comment_id = insert_record("ia_assign_submissions_comment", $newentry);
                if (!$ia_assign_submissions_comment_id) {
                    return_home_course(get_string('error_insert', 'ia'));
                   // die;
                } else {
                    add_to_log($this->course->id, "ia", "add comment", "view.php?id={$this->ia->id}", $ia_assign_submissions_comment_id, $this->cm->id, $USER->id);
                    $this->view_assign_current();
                   // die;
                } //if (!$newentry->id = insert_record("ia_assign_submissions_comment", $newentry))
            }
        } //if (!empty($submission_comment) and (strcmp($str1, $str2) != 0))

        $this->view_header(get_string('submit_comment_message', 'ia'));
        $this->return_last('empty_comment', $link_return);
    }

    /**
     * Writes a new submission
     */

    function new_submission($id_ia, $id_user, $receiver) {
        global $USER;
        $newentry->ia_assign_id = $id_ia;
        $newentry->user_id = $id_user;
        $newentry->timecreated = time();
        $newentry->timemodified = time();
        $newentry->answer = 0; // student only submit message
        if ($receiver == 2)// teacher message to student (write id teacher)
            $newentry->teacher = $USER->id;

        if (!$newentry->id = insert_record("ia_assign_submissions", $newentry)) 
            return_home_course(get_string('error_insert_submissions', 'ia'));
        else
            add_to_log($this->course->id, "ia", "add submission", "view.php?id={$this->ia->id}", $newentry->id, $this->cm->id, $USER->id);

        return $newentry->id;
    }

    /**
     * Return to a specific address of page
     */
    function return_last($message, $link_return) {
        print_simple_box_start('center');
        echo '<table width=100% border=0 valign="top">';
        echo '<tr><td align="left"><strong>';
        print_string($message, 'ia');
        echo '</strong></td>';
        echo '<td width=20% align="right">';
        echo $link_return;
        echo '</td></tr></table>';
        print_simple_box_end();
        $this->view_footer();
        die;
    }

   /**
     * View iGeom editor online
     * @author: Luciano Oliveira Borges
     * @last modification date 2013/04/02
     */
    function ima_editor () {
        global $USER, $CFG, $COURSE;

        //inicio: inserido pela Patricia        
        $assign_id = optional_param('assign_id', 0, PARAM_INT); // Assign ID
        $ia_assign = get_record('ia_assign','id',$assign_id);
        //termino				

        //inicio: inserido pelo Luciano (02/04/2013)
        $ia_ima_id = $_GET['ia_ima'];
        $ia_ima = get_record("ia_ima", "id", $ia_ima_id);

        $nome = $ia_ima->name;
        $file_jar = $ia_ima->file_jar;
        $arquivo_class = $ia_ima->file_class;
        $largura = $ia_ima->width;
        $altura = $ia_ima->heigth;
        $extensao = $ia_ima->extension;
        //termino

        $ia_content = "";
        $ia_file = $_GET['ia_file'];

        //if ($ia_file != "" && $_POST['MA_POST_Archive'] == "")// alterado por Patricia
        if ($ia_file != "" && empty($_POST)) {
           $path = "$CFG->dataroot/$COURSE->id/$ia_file";
           $ia_content = file_get_contents($path, true);
           }
        echo "<script type='text/javascript'>\n";
        echo "function submit_MA_Answer () {\n";
        echo " var docForm = document.formEnvio;\n";
        echo " var resposta_exerc = new Array(3); \n";
        echo " var valor_resposta = new Array(3); \n";
        echo " var sessao = new Array(3);\n";
        echo " var doc = document.eMA; \n";
        echo " resposta_exerc[0] = doc.getAnswer();\n";
        echo " valor_resposta[0] = doc.getEvaluation();\n";
        echo " docForm.MA_POST_Value.value = valor_resposta[0]; \n";
        echo " docForm.MA_POST_Archive.value = resposta_exerc[0];\n";
        echo " if (resposta_exerc[0] == 'Vazio'){alert('".get_string('error_null_ia', 'ia')."');return false;}\n";
        if ($ia_file != "") {
           echo " if (!docForm.MA_POST_Version.checked){";
           // echo " var answer = confirm('".utf8_decode(get_string('overwrite_file_ia', 'ia'))."');";
           echo " var answer = confirm('".get_string('overwrite_file_ia', 'ia')."');";
           echo " if (answer){";
           echo " docForm.submit(); \n";
           echo " return true;\n";
           echo " } else {\n";
           echo " return false;\n";
           echo " }\n";
           echo " } else {";
           echo " docForm.submit(); \n";
           echo " return true;\n";
           echo " }\n";           
         } else {
           echo " docForm.submit(); \n";
           echo " return true;\n";
           }
         echo " }\n";
         echo "</script>\n";
         echo "<table width='100%'><tr><td colspan='2'><center><b>".get_string('title_editor_ia', 'ia')."</b>";
         echo "<a title='".get_string('help_button_ia', 'ia')."' href='$CFG->wwwroot/help.php?module=ia&amp;file=editor.html&amp;forcelang=' ";
         echo "onclick=\"this.target='popup'; return openpopup('/help.php?module=ia&amp;file=editor.html&amp;forcelang=', 'popup', 'menubar=0,location=0,scrollbars,resizable,width=500,height=400', 0);\">";
         echo "<img class='iconhelp' alt='".get_string('help_button_ia', 'ia')."' src='$CFG->wwwroot/pix/help.gif'></a>";
         echo "</center></td></tr>";

         // comentado pela Patricia: Moodle converte todas as string para utf8 ao compor os HTML
         //echo "<tr><td width='50%'>".get_string('label_author_ia', 'ia')."<b>".utf8_decode($USER->firstname . ' ' . $USER->lastname)."</td><td width='50%'>".get_string('label_course_ia', 'ia')."<b>".utf8_decode($COURSE->shortname)."<b></td></tr>";
         //echo "<tr><td width='50%'>".utf8_decode(get_string('label_title_ia', 'ia'))."<b>".utf8_decode($_GET['ia_name'])."</b> </td><td width='50%'>".get_string('label_file_ia', 'ia')."<b>$ia_file</b></td></tr>";

         if ($ia_assign)
           echo "<tr><td width='50%'>".get_string('label_author_ia', 'ia')."<b>".$ia_assign->author_name."</td><td width='50%'>".get_string('label_course_ia', 'ia')."<b>".$COURSE->shortname."<b></td></tr>";
         else
           echo "<tr><td width='50%'>".get_string('label_author_ia', 'ia')."<b>".$USER->firstname . ' ' . $USER->lastname."</td><td width='50%'>".get_string('label_course_ia', 'ia')."<b>".$COURSE->shortname."<b></td></tr>";

         echo "<tr><td width='50%'>".get_string('label_title_ia', 'ia')."<b>".$_GET['ia_name']."</b> </td><td width='50%'>".get_string('label_file_ia', 'ia')."<b>$ia_file</b></td></tr>";
         echo "</table>";
         echo "<center>\n";
         echo "<form name='formEnvio' id='formEnvio' method='post' enctype='multipart/form-data'>\n";
         // Inicio: modificado por Luciano (02/04/2013)
         echo "<applet name='eMA' codebase='./ma/' code='".$arquivo_class."' archive='".$file_jar."' WIDTH='".$largura."' HEIGHT='".$altura."' vspace='10' hspace='10'>\n";
         // Termino
         echo "<param name='lang' value='pt'/>\n";
         echo "<param name='MA_PARAM_Proposition' value='$ia_content'/>\n";
         echo "</applet>\n";
         echo "<br/>\n";
         echo "<input type='hidden' name='MA_POST_Archive'/>\n";
         echo "<input type='hidden' name='MA_POST_Value'/>\n";
         echo "<input type='hidden' name='MA_POST_Name' value='".$_GET['ia_name']."'/>\n";
         echo "<center>\n";

         //if ($ia_file != "" && $_POST['MA_POST_Archive'] == "") // alterado pela Patricia
         if ($ia_file != "" && empty ($_POST)) {
            //echo "<input name='MA_POST_Version' type=checkbox value='Y'><font color=red>".utf8_decode(get_string('question_version_ia', 'ia'))."</font></br>\n";
            echo "<input name='MA_POST_Version' type=checkbox value='Y'><font color=red>".get_string('question_version_ia', 'ia')."</font></br>\n";
            }
         echo "<input type=button value='".get_string('label_write_ia', 'ia')."' title='' onclick='submit_MA_Answer();'/>\n";
         echo "</center>\n";
         echo "</form>\n";
         echo "</center>\n";
                
         //if ($_POST['MA_POST_Archive'] != "")
         if (!empty ($_POST)) {
           // Inicio: modificado por Luciano (02/04/2013)
           $filename = $_POST['MA_POST_Name'];
           if ($ia_file != "")
              $filename = $ia_file;
           else
              $filename = "ilm_".strtolower($nome);
           $this->ima_save_files($filename, $CFG->dataroot, $COURSE->id, $_POST['MA_POST_Archive'], $ia_file != "" && $_POST['MA_POST_Version'] != 'Y', $extensao);
           // Termino
           }
         die;
     } // function ima_editor()

   /**
     * Save iGeom file
     * @author: Luciano Oliveira Borges
     * @last modification date 2013/04/02
     */
    function ima_save_files($filename, $data_folder, $course, $content, $file_exists, $extension) {
         $cont = -1;
         $filename = $this->format_filename($filename);
         if (!$file_exists) {
           $afile = explode(".", $filename);
           if (count($afile) > 1)
              array_pop($afile);
           $filename = join("", $afile);
           $afile = explode("_v", $filename);
           if (count($afile) > 1)
              array_pop($afile);
           $filename = join("", $afile);
           do {
              if ($cont == -1)
                 $file = "$filename.".$extension;
              else
                 $file = $filename."_v"."$cont.".$extension;
              $path = "$data_folder/$course/$file";
              $cont++;
           } while(file_exists($path));
         } else {
           $file = "$filename";
           $path = "$data_folder/$course/$filename";
           }
         $fh = fopen($path, 'w') or die("<script>alert('".get_string('error_write_ia', 'ia')."');</script>");
         fwrite($fh, $content);
         fclose($fh);
         echo("<script>alert('".get_string('sucess_write_ia', 'ia', $file)."');\n");
         echo("window.opener.document.getElementById('id_file_value').value = '$file';\n");
         die("window.close();</script>");
         }

   /**
     * Format filename for save in data dir.
     * @author: Luciano Oliveira Borges
     * @last modification date 2011/11/16
     */
     function format_filename ($text) {
         $text = htmlspecialchars(urldecode($text));
         $array1 = array( "á", "à", "â", "ã", "ä", "é", "è", "ê", "ë", "í", "ì", "î", "ï", "ó", "ò", "ô", "õ", "ö", "ú", "ù", "û", "ü", "ç",
                          "Á", "À", "Â", "Ã", "Ä", "É", "È", "Ê", "Ë", "Í", "Ì", "Î", "Ï", "Ó", "Ò", "Ô", "Õ", "Ö", "Ú", "Ù", "Û", "Ü", "Ç",
                          "@", " ", "!", "?");
         $array2 = array( "a", "a", "a", "a", "a", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", "o", "u", "u", "u", "u", "c",
                          "A", "A", "A", "A", "A", "E", "E", "E", "E", "I", "I", "I", "I", "O", "O", "O", "O", "O", "U", "U", "U", "U", "C",
                          "-", "_", "", "");
         return str_replace( $array1, $array2, $text );
         }

   }
?>
