<?php 
/** * @description Form to display activities iAssign
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: index.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2010/12/21
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */




    require_once("../../config.php");
    require_once("lib.php");

    $id = required_param('id', PARAM_INT);   // course
  
    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);

    add_to_log($course->id, "ia", "view all", "index.php?id=$course->id", "");


/// Get all required stringsia

    $strias = get_string("modulenameplural", "ia");
    $stria  = get_string("modulename", "ia");



/// Print the header

    $navlinks = array();
    $navlinks[] = array('name' => $strias, 'link' => "view.php?id=$id", 'type' => 'activity');
    $navigation = build_navigation($navlinks);

    print_header_simple($strias, "", $navigation, "", "", true, "", navmenu($course));

/// Get all the appropriate data

    if (! $ias = get_all_instances_in_course("ia", $course)) {
        notice(get_string('thereareno', 'moodle', $strias), "../../course/view.php?id=$course->id");
        //notice("There are no ias", "../../course/view.php?id=$course->id");
        die;
    }

/// Print the list of instances (your module will probably extend this)

    $timenow = time();
    $strname  = get_string("name");
    $strweek  = get_string("week");
    $strtopic  = get_string("topic");

    if ($course->format == "weeks") {
        $table->head  = array ($strweek, $strname);
        $table->align = array ("center", "left");
    } else if ($course->format == "topics") {
        $table->head  = array ($strtopic, $strname);
        $table->align = array ("center", "left", "left", "left");
    } else {
        $table->head  = array ($strname);
        $table->align = array ("left", "left", "left");
    }

    foreach ($ias as $ia) {
        if (!$ia->visible) {
            //Show dimmed if the mod is hidden
            $link = "<a class=\"dimmed\" href=\"view.php?id=$ia->coursemodule\">$ia->name</a>";
        } else {
            //Show normal if the mod is visible
            $link = "<a href=\"view.php?id=$ia->coursemodule\">$ia->name</a>";
        }

        if ($course->format == "weeks" or $course->format == "topics") {
            $table->data[] = array ($ia->section, $link);
        } else {
            $table->data[] = array ($link);
        }
    }

    echo "<br />";



    print_table($table);

/// Finish the page

    print_footer($course);

?>
