<?php

/** * @description This php script contains all the stuff to restore interactive activities
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: restorelib.php$ v 1.0 2010/10/23$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2010/12/21
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */

//This is the "graphical" structure of the ia mod:
//
//                ia
//           (CL,pk->id)
//                |
//                |
//                |
//            ia_assigns
//         (UL,pk->id,fk->ia)
//                |
//                |
//       ia_assigns_submissions
//       (UL,pk->id,fk->ia_assigns)
//                |
//                |
//     ia_assigns_submissions_comment
//(UL,pk->id,fk->ia_assigns_submissions)
//
//
// Meaning: pk->primary key field of the table
//          fk->foreign key to link with parent
//          nt->nested field (recursive data)
//          CL->course level info
//          UL->user level info
//          files->table may have files)
//
//-----------------------------------------------------------


//This function executes all the restore procedure about this mod
function ia_restore_mods($mod,$restore) {

    global $CFG;

    $status = true;
    echo "<ul>";
    //Get record from backup_ids
    $data = backup_getid($restore->backup_unique_code,$mod->modtype,$mod->id);
    if ($data) {
        //Now get completed xmlized object
        $info = $data->info;

        //Now, build the IA record structure
        $ia->course = $restore->course_id;
        $ia->name = backup_todb($info['MOD']['#']['NAME']['0']['#']);
        $ia->activity_group = backup_todb($info['MOD']['#']['ACTIVITY_GROUP']['0']['#']);

        //The structure is equal to the db, so insert the ia
        $newid = insert_record ("ia",$ia);

        //Do some output
        if (!defined('RESTORE_SILENTLY')) {
            echo "<ul><li>".get_string("modulename","ia")." \"".format_string(stripslashes($ia->name),true)."\"</li></ul>";
        }
        backup_flush(300);

        if ($newid) {
            //We have the newid, update backup_ids
            backup_putid($restore->backup_unique_code,$mod->modtype,
                    $mod->id, $newid);

            //Now check if want to restore user data and do it.
            //  if (restore_userdata_selected($restore,'ia',$mod->id)) {  //restore_userdata_selected($restore, $modname, $modid)
            //Restore ia_submissions
            $status = ia_assign_restore_mods($mod->id, $newid,$info,$restore,$ia,$mod->id); //&& $status;

            $ia->cmidnumber='ia';
            $ia->id = $newid;
            $ia=(stripslashes_recursive($ia));
            $ia->grade=0;
            $grades = NULL;

            if (array_key_exists('cmidnumber', $ia)) { //it may not be always present
               $params = array('itemname'=>$ia->name, 'idnumber'=>$ia->cmidnumber);
            }else {
               $params = array('itemname'=>$ia->name);
            }

            if ($ia->grade > 0) {
               $params['gradetype']  = GRADE_TYPE_VALUE;
               $params['grademax']   = $ia->grade;
               $params['grademin']   = 0;

           } else {
               $params['gradetype']  = GRADE_TYPE_NONE;
           }

          if ($grades  === 'reset') {
             $params['reset'] = true;
             $grades = NULL;
          } else if (!empty($grades)) {
          // Need to calculate raw grade (Note: $grades has many forms)
          if (is_object($grades)) {
              $grades = array($grades->userid => $grades);
          } else if (array_key_exists('userid', $grades)) {
              $grades = array($grades['userid'] => $grades);
          }
          foreach ($grades as $key => $grade) {
                  $grades[$key] = $grade = (array) $grade;
              }
               $grades[$key]['rawgrade'] = ($grade['rawgrade'] * $ia->grade / 100);
           }

          grade_update('mod/ia', $ia->course, 'mod', 'ia', $ia->id, 0, $grades, $params);


      /*
        // $ia= get_record('ia','id',$newid) ;
        $ia->id=$newid;
        $ia->grade=0;

        // inserir atividades na tabela
       require_once($CFG->libdir.'/gradelib.php');
      $params = array('itemname'=>$ia->name);
      $params['iteminstance']=$ia->id;
      $params['gradetype'] = GRADE_TYPE_VALUE;
      $params['grademax']  = $ia->grade;
      $params['grademin']  = 0;
      grade_update('mod/ia', $ia->course, 'mod', 'ia', $ia->id, 0, $grades, $params);

         $sum_grade =get_records_sql ("SELECT SUM(grade) as total
                             FROM {$CFG->prefix}ia_assign s
                             WHERE s.ia_id = '$ia->id'
                             AND s.type_assign=3");

         $update_grade=get_record('grade_items','iteminstance',$newid);

         $updateentry->id=$update_grade->id;
         $updateentry->grademax=key($sum_grade);
         if (! insert_record ("grade_items", $updateentry)) {
            error(get_string('error_update', 'grade_items'));
         }

*/
        } else {
            $status = false;
        }
        //Finalize ul
        if (!defined('RESTORE_SILENTLY')) {
            echo "</ul>";
        }

        





    } else {
        $status = false;
    }



    return $status;
}


//This function restores the ia_submissions
function ia_assign_restore_mods($old_ia_id, $new_ia_id,$info,$restore, $ia,$mod_id) {
    global $CFG;
    $status = true;
    //Get the assigns array - it might not be present
    if (isset($info['MOD']['#']['ASSIGNS']['0']['#']['ASSIGN'])) {
        $assigns = $info['MOD']['#']['ASSIGNS']['0']['#']['ASSIGN'];
    } else {
        $assigns = array();
    }
    echo "<ul>";
    //Iterate over submissions
    for($i = 0; $i < sizeof($assigns); $i++) {
        $assign_info = $assigns[$i];

        //We'll need this later!!
        $oldid = backup_todb($assign_info['#']['ID']['0']['#']);

        //Now, build the IA_ASSIGN_SUBMISSIONS record structure
        $assign->ia_id = $new_ia_id;
        $assign->name = backup_todb($assign_info['#']['NAME']['0']['#']);
        $assign->type_assign = backup_todb($assign_info['#']['TYPE_ASSIGN']['0']['#']);
        $assign->proposition = backup_todb($assign_info['#']['PROPOSITION']['0']['#']);
        $assign->author_name = backup_todb($assign_info['#']['AUTHOR_NAME']['0']['#']);
        $assign->author_modified_name = backup_todb($assign_info['#']['AUTHOR_MODIFIED_NAME']['0']['#']);

        //busca o ia_ima_id do arquivo jar na tabela ia_ima
        $file_jar = backup_todb($assign_info['#']['FILE_JAR']['0']['#']);
        $ia_ima = get_record('ia_ima','file_jar',$file_jar);

        if (count($ia_ima)<1) {
            $assign->ia_ima_id = 0; // durante a restauração o arquivo iMA não foi encontrado na tabela ia_ima
            echo get_string('error_confirms_ima','ia');
        }
        else
            $assign->ia_ima_id = $ia_ima->id;

        $assign->file = backup_todb($assign_info['#']['FILE']['0']['#']);
        $assign->grade = backup_todb($assign_info['#']['GRADE']['0']['#']);
        $assign->timemodified = backup_todb($assign_info['#']['TIMEMODIFIED']['0']['#']);
        $assign->timecreated = backup_todb($assign_info['#']['TIMECREATED']['0']['#']);
        $assign->timeavailable = backup_todb($assign_info['#']['TIMEAVAILABLE']['0']['#']);
        $assign->timedue = backup_todb($assign_info['#']['TIMEDUE']['0']['#']);
        $assign->preventlate = backup_todb($assign_info['#']['PREVENTLATE']['0']['#']);
        $assign->test = backup_todb($assign_info['#']['TEST']['0']['#']);
        $assign->special_param1 = backup_todb($assign_info['#']['SPECIAL_PARAM1']['0']['#']);
        $assign->position = backup_todb($assign_info['#']['POSITION']['0']['#']);
        $assign->visible = backup_todb($assign_info['#']['VISIBLE']['0']['#']);
        $assign->max_experiment = backup_todb($assign_info['#']['MAX_EXPERIMENT']['0']['#']);
        $assign->dependency = backup_todb($assign_info['#']['DEPENDENCY']['0']['#']);
        $assign->automatic_evaluate = backup_todb($assign_info['#']['AUTOMATIC_EVALUATE']['0']['#']);
        $assign->show_answer = backup_todb($assign_info['#']['SHOW_ANSWER']['0']['#']);   

        //The structure is equal to the db, so insert the assignment_submission
        $newid = insert_record ("ia_assign",$assign);

        echo "<ul><li>".$assign->name."</li></ul>";
        //Do some output
        if (($i+1) % 50 == 0) {
            if (!defined('RESTORE_SILENTLY')) {
                echo ".";
                if (($i+1) % 1000 == 0) {
                    echo "<br />";
                }
            }
            backup_flush(300);
        }



        if ($newid) {
            //We have the newid, update backup_ids
            backup_putid($restore->backup_unique_code,"ia_assign",$oldid,$newid);

            $temp_path = $CFG->dataroot."/temp/backup/".$restore->backup_unique_code."/course_files/";
            $check=check_dir_exists($temp_path,false);
            if(!$check)
               $status=ia_restore_files ($restore,$assign->file );
           
            //Now check if want to restore user data and do it.
            if (restore_userdata_selected($restore,'ia',$mod_id)) {
                //Restore ia_submissions
                $status = ia_assign_submissions_restore_mods($oldid,$newid,$assign_info,$restore); //&& $status;

            }
            //else {
                //$status = false;
          //  }
        }

    }
    echo "</ul>";
    return $status;
}



    function ia_restore_files ($restore,$file_name) {
        global $CFG;
        $status = true;
        $temp_path = "";

        //First, we check to "course_id" exists and create is as necessary
        //in CFG->dataroot
        $dest_dir = $CFG->dataroot."/".$restore->course_id;
        $status = check_dir_exists($dest_dir,true);
      
        //Now locate the temp dir we are gong to restore
        if ($status) {
            $temp_path = $CFG->dataroot."/temp/backup/".$restore->backup_unique_code.
                         "/moddata/ia/".$file_name;
        }

        if ($status) {
           $status = backup_copy_file($temp_path,
                                      $dest_dir."/".$file_name);
        }
        return $status;
    }






//This function restores the ia_assign_submissions
function ia_assign_submissions_restore_mods($oldid, $new_assign_id,$info,$restore, $ia) {
    global $CFG;
    $status = true;
    //Get the submissions array - it might not be present
    if (isset($info['#']['SUBMISSIONS']['0']['#']['SUBMISSION'])) {
        $submissions = $info['#']['SUBMISSIONS']['0']['#']['SUBMISSION'];
    } else {
        $submissions = array();
    }

    //Iterate over submissions
    for($i = 0; $i < sizeof($submissions); $i++) {
        $sub_info = $submissions[$i];

        //We'll need this later!!
        $oldid = backup_todb($sub_info['#']['ID']['0']['#']);
        $olduserid = backup_todb($sub_info['#']['USER_ID']['0']['#']);

        //Now, build the IA_ASSIGN_SUBMISSIONS record structure
        $submission->ia_assign_id =$new_assign_id;
        $submission->user_id = backup_todb($sub_info['#']['USER_ID']['0']['#']);
        $submission->timecreated = backup_todb($sub_info['#']['TIMECREATED']['0']['#']);
        $submission->timemodified = backup_todb($sub_info['#']['TIMEMODIFIED']['0']['#']);
        $submission->grade = backup_todb($sub_info['#']['GRADE']['0']['#']);
        $submission->teacher = backup_todb($sub_info['#']['TEACHER']['0']['#']);
        $submission->answer = backup_todb($sub_info['#']['ANSWER']['0']['#']);
        $submission->experiment = backup_todb($sub_info['#']['EXPERIMENT']['0']['#']);
        $submission->status = backup_todb($sub_info['#']['STATUS']['0']['#']);

        //We have to recode the userid field
        $user = backup_getid($restore->backup_unique_code,"user",$submission->user_id);
        if ($user) {
            $submission->user_id = $user->new_id;
        }

        //We have to recode the teacher field
        $user = backup_getid($restore->backup_unique_code,"user",$submission->teacher);
        if ($user) {
            $submission->teacher = $user->new_id;
        }
        //The structure is equal to the db, so insert the assignment_submission
        $newid = insert_record ("ia_assign_submissions",$submission);

        //Do some output
        if (($i+1) % 50 == 0) {
            if (!defined('RESTORE_SILENTLY')) {
                echo ".";
                if (($i+1) % 1000 == 0) {
                    echo "<br />";
                }
            }
            backup_flush(300);
        }

        if ($newid) {
            //We have the newid, update backup_ids
            backup_putid($restore->backup_unique_code,"ia_assign_submissions",$oldid,
                    $newid);
            //Restore ia_submissions_comment
            $status = ia_submissions_restore_comment_mods($oldid,$newid,$sub_info,$restore); //&& $status;
        }
        else {
            $status = false;
        }
    }
    return $status;
}


//This function restores the ia_submissions_comment
function ia_submissions_restore_comment_mods($old_submission_id,$new_submission_id,$sub_info,$restore) {
    global $CFG;
    $status = true;
    //Get the submissions array - it might not be present
    if (isset($sub_info['#']['SUBMISSIONS_COMMENTS']['0']['#']['SUBMISSION_COMMENT'])) {
        $submissions_comment = $sub_info['#']['SUBMISSIONS_COMMENTS']['0']['#']['SUBMISSION_COMMENT'];
    }
    else {
        $submissions_comment = array();
    }
    //Iterate over submissions
    for($i = 0; $i < sizeof($submissions_comment); $i++) {
        $sub_comment_info = $submissions_comment[$i];
        //We'll need this later!!
        $oldsubidcomment = backup_todb($sub_comment_info['#']['ID']['0']['#']);
        //Now, build the IA_SUBMISSIONS_COMMENT record structure
        $submission_comment->submission_id = $new_submission_id;
        $submission_comment->comment_author_id = backup_todb($sub_comment_info['#']['COMMENT_AUTHOR_ID']['0']['#']);
        $submission_comment->timecreated = backup_todb($sub_comment_info['#']['TIMECREATED']['0']['#']);
        $submission_comment->comment = backup_todb($sub_comment_info['#']['COMMENT']['0']['#']);
        $submission_comment->return_status = backup_todb($sub_comment_info['#']['RETURN_STATUS']['0']['#']);
        $submission_comment->receiver = backup_todb($sub_comment_info['#']['RECEIVER']['0']['#']);

        //We have to recode the author field
        $user = backup_getid($restore->backup_unique_code,"user",$submission_comment->comment_author_id);
        if ($user) {
            $submission_comment->comment_author_id = $user->new_id;
        }

        //The structure is equal to the db, so insert the assignment_submission
        $newid = insert_record ("ia_assign_submissions_comment",$submission_comment);

        //Do some output
        if (($i+1) % 50 == 0) {
            if (!defined('RESTORE_SILENTLY')) {
                echo ".";
                if (($i+1) % 1000 == 0) {
                    echo "<br />";
                }
            }
            backup_flush(300);
        }
        if ($newid) {
            //We have the newid, update backup_ids
            backup_putid($restore->backup_unique_code,"ia_assign_submissions_comment",$oldsubidcomment, $newid);
        } else {
            $status = false;
        }
    }
    return $status;
}

?>
